diff -r -uw -N irrlicht/source/Irrlicht/CD3D9MDriver.cpp irrlicht_multipatch/source/Irrlicht/CD3D9MDriver.cpp
--- irrlicht/source/Irrlicht/CD3D9MDriver.cpp	1970-01-01 01:00:00.000000000 +0100
+++ irrlicht_multipatch/source/Irrlicht/CD3D9MDriver.cpp	2006-12-11 14:01:04.000000000 +0100
@@ -0,0 +1,2419 @@
+// Copyright (C) 2002-2006 Nikolaus Gebhardt
+// This file is part of the "Irrlicht Engine".
+// For conditions of distribution and use, see copyright notice in irrlicht.h
+
+#define _IRR_DONT_DO_MEMORY_DEBUGGING_HERE
+#include "CD3D9MDriver.h"
+#include "os.h"
+#include "S3DVertex.h"
+#include "CD3D9Texture.h"
+#include "CImage.h"
+#include <stdio.h>
+
+#include "IrrCompileConfig.h"
+#ifdef _IRR_WINDOWS_
+
+#ifdef _IRR_COMPILE_WITH_DIRECT3D_9_
+
+#include "CD3D9MaterialRenderer.h"
+#include "CD3D9ShaderMaterialRenderer.h"
+#include "CD3D9NormalMapRenderer.h"
+#include "CD3D9ParallaxMapRenderer.h"
+#include "CD3D9HLSLMaterialRenderer.h"
+
+namespace irr
+{
+namespace video
+{
+
+
+//! constructor
+CD3D9MDriver::CD3D9MDriver(const core::dimension2d<s32>& screenSize, HWND window,
+				bool fullscreen, bool stencilbuffer,
+				io::IFileSystem* io, bool pureSoftware)
+: CNullDriver(io, screenSize), D3DLibrary(0), CurrentRenderMode(ERM_NONE), pID3DDevice(0),
+ pID3D(0), Transformation3DChanged(0), StencilBuffer(stencilbuffer),
+ DeviceLost(false), Fullscreen(fullscreen), PrevRenderTarget(0), CurrentRendertargetSize(0,0)
+{
+	#ifdef _DEBUG
+	setDebugName("CD3D9MDriver");
+	#endif
+
+	printVersion();
+
+	for (s32 i=0; i<MATERIAL_MAX_TEXTURES; ++i)
+	{
+		CurrentTexture[i] = 0;
+		LastTextureMipMapsAvailable[i] = false;
+	}
+
+	// init direct 3d is done in the factory function
+
+	MaxLightDistance = sqrtf(FLT_MAX);
+
+	m_pSwapChain = NULL;
+	m_pBackBuffer = NULL;
+	m_curMode = NULL;
+	m_beginScene = false;
+	m_renderAdapter = 0;
+}
+
+
+
+//! destructor
+CD3D9MDriver::~CD3D9MDriver()
+{
+	u32 idx = 0;
+	deleteMaterialRenders();
+
+	for (s32 i=0; i<MATERIAL_MAX_TEXTURES; ++i)
+		if (CurrentTexture[i])
+			CurrentTexture[i]->drop();
+
+	for(idx = 0; Matricess.size(); ++idx)
+	{
+		if(Matricess[idx])
+			delete []Matricess[idx];
+	}
+	Matricess.clear();
+	// drop d3d9
+
+	for(idx = 1; idx < pID3DDevices.size(); ++idx)
+	{
+		if(pID3DDevices[idx])
+			pID3DDevices[idx]->Release();
+	}
+	pID3DDevices.clear();
+
+	for(idx = 0; idx < m_pPresentParams.size(); ++idx)
+	{
+		if(m_pPresentParams[idx] && m_pPresentParams[idx] != NULL)
+		{
+			delete[]m_pPresentParams[idx];
+		}
+	}
+	m_pPresentParams.clear();
+
+	if (pID3D)		
+		pID3D->Release();
+}
+
+
+
+void CD3D9MDriver::createMaterialRenderers()
+{
+	// create D3D9 material renderers
+
+	addAndDropMaterialRenderer(new CD3D9MaterialRenderer_SOLID(pID3DDevices, this));
+	addAndDropMaterialRenderer(new CD3D9MaterialRenderer_SOLID_2_LAYER(pID3DDevices, this));
+
+	// add the same renderer for all lightmap types
+
+	CD3D9MaterialRenderer_LIGHTMAP* lmr = new CD3D9MaterialRenderer_LIGHTMAP(pID3DDevices, this);
+	addMaterialRenderer(lmr); // for EMT_LIGHTMAP:
+	addMaterialRenderer(lmr); // for EMT_LIGHTMAP_ADD:
+	addMaterialRenderer(lmr); // for EMT_LIGHTMAP_M2:
+	addMaterialRenderer(lmr); // for EMT_LIGHTMAP_M4:
+	addMaterialRenderer(lmr); // for EMT_LIGHTMAP_LIGHTING:
+	addMaterialRenderer(lmr); // for EMT_LIGHTMAP_LIGHTING_M2:
+	addMaterialRenderer(lmr); // for EMT_LIGHTMAP_LIGHTING_M4:
+	lmr->drop();
+
+	// add remaining fixed function pipeline material renderers
+
+	addAndDropMaterialRenderer(new CD3D9MaterialRenderer_DETAIL_MAP(pID3DDevices, this));
+	addAndDropMaterialRenderer(new CD3D9MaterialRenderer_SPHERE_MAP(pID3DDevices, this));
+	addAndDropMaterialRenderer(new CD3D9MaterialRenderer_REFLECTION_2_LAYER(pID3DDevices, this));
+	addAndDropMaterialRenderer(new CD3D9MaterialRenderer_TRANSPARENT_ADD_COLOR(pID3DDevices, this));
+	addAndDropMaterialRenderer(new CD3D9MaterialRenderer_TRANSPARENT_ALPHA_CHANNEL(pID3DDevices, this));
+	addAndDropMaterialRenderer(new CD3D9MaterialRenderer_TRANSPARENT_ALPHA_CHANNEL_REF(pID3DDevices, this));
+	addAndDropMaterialRenderer(new CD3D9MaterialRenderer_TRANSPARENT_VERTEX_ALPHA(pID3DDevices, this));
+	addAndDropMaterialRenderer(new CD3D9MaterialRenderer_TRANSPARENT_REFLECTION_2_LAYER(pID3DDevices, this));
+
+	// add normal map renderers
+
+	s32 tmp = 0;
+	video::IMaterialRenderer* renderer = 0;
+
+	renderer = new CD3D9NormalMapRenderer(pID3DDevices, this, tmp,
+		MaterialRenderers[EMT_SOLID].Renderer);
+	renderer->drop();
+
+	renderer = new CD3D9NormalMapRenderer(pID3DDevices, this, tmp,
+		MaterialRenderers[EMT_TRANSPARENT_ADD_COLOR].Renderer);
+	renderer->drop();
+
+	renderer = new CD3D9NormalMapRenderer(pID3DDevices, this, tmp,
+		MaterialRenderers[EMT_TRANSPARENT_VERTEX_ALPHA].Renderer);
+	renderer->drop();
+
+	// add parallax map renderers
+
+	renderer = new CD3D9ParallaxMapRenderer(pID3DDevices, this, tmp,
+		MaterialRenderers[EMT_SOLID].Renderer);
+	renderer->drop();
+
+	renderer = new CD3D9ParallaxMapRenderer(pID3DDevices, this, tmp,
+		MaterialRenderers[EMT_TRANSPARENT_ADD_COLOR].Renderer);
+	renderer->drop();
+
+	renderer = new CD3D9ParallaxMapRenderer(pID3DDevices, this, tmp,
+		MaterialRenderers[EMT_TRANSPARENT_VERTEX_ALPHA].Renderer);
+	renderer->drop();
+}
+
+bool CD3D9MDriver::findMultiHeadDevice()
+{
+	HRESULT hr;
+	UINT adapterCount = pID3D->GetAdapterCount();
+	bool result = false;
+	m_Device.iNumAdapters = 0;
+
+    for ( UINT i = 0; i < adapterCount; i++ )
+    {
+        // Get caps for HAL device
+		D3DCAPS9 caps;
+		hr = pID3D->GetDeviceCaps( i, D3DDEVTYPE_HAL, &caps );
+
+		// Look for multi-head adpater
+		if ( caps.NumberOfAdaptersInGroup > 1 )
+		{
+			// Get device name
+			D3DADAPTER_IDENTIFIER9 identifier;
+			hr = pID3D->GetAdapterIdentifier( i, 0, &identifier );
+
+			strcpy( m_Device.Adapters[m_Device.iNumAdapters].DeviceName, identifier.Description );
+			m_Device.Adapters[m_Device.iNumAdapters].AdapterID = i;
+			m_Device.Adapters[m_Device.iNumAdapters].Ordinal = caps.NumberOfAdaptersInGroup;
+			m_Device.Adapters[m_Device.iNumAdapters].iNumModes = 0;
+			m_Device.Adapters[m_Device.iNumAdapters].CurrMode = NULL;
+			m_Device.Adapters[m_Device.iNumAdapters].pDepthStencil = NULL;
+
+			m_Device.iNumAdapters++;
+			result = true;
+		}
+    }
+
+	return result;
+}
+
+//! build presents params for d3d device
+void CD3D9MDriver::buildPresentParams(const core::array<core::dimension2d<s32> >& screenSize, core::array<HWND> hwnd, u32 bits, bool vsync)
+{
+	u32 hwndCnt = 0;
+	for(u32 idx = 0; idx < m_Device.iNumAdapters; ++idx)
+	{	
+		m_pPresentParams.push_back(new D3DPRESENT_PARAMETERS[m_Device.Adapters[idx].Ordinal]);
+
+		D3DPRESENT_PARAMETERS *tmp = m_pPresentParams[m_pPresentParams.size()-1];
+
+		memset( tmp, 0, sizeof( D3DPRESENT_PARAMETERS ) * m_Device.Adapters[idx].Ordinal );
+
+		// Initialize presentation params
+		for ( UINT i = 0; i < m_Device.Adapters[idx].Ordinal ; i++ )
+		{
+			tmp[i].BackBufferWidth = screenSize[i].Width;
+			tmp[i].BackBufferHeight = screenSize[i].Height;
+			tmp[i].BackBufferFormat = D3DFMT_R5G6B5;
+			tmp[i].BackBufferCount = 1;
+			//m_pPresentParams[i].MultiSampleType = D3DMULTISAMPLE_NONE;	//???
+			//m_pPresentParams[i].MultiSampleQuality = 0;					//???
+			tmp[i].SwapEffect = D3DSWAPEFFECT_FLIP;
+			tmp[i].hDeviceWindow = hwnd[hwndCnt++];
+			tmp[i].Windowed = FALSE;
+			tmp[i].EnableAutoDepthStencil = true;
+			tmp[i].AutoDepthStencilFormat = D3DFMT_D24S8;
+			tmp[i].Flags = 0;
+			tmp[i].FullScreen_RefreshRateInHz = D3DPRESENT_RATE_DEFAULT;
+			tmp[i].PresentationInterval = D3DPRESENT_INTERVAL_IMMEDIATE;
+
+			if (vsync)
+				tmp[i].PresentationInterval = D3DPRESENT_INTERVAL_ONE;
+			
+			// request 32bit mode if user specified 32 bit, added by Thomas Stüfe
+			if ( bits == 32 ) 
+				tmp[i].BackBufferFormat = D3DFMT_A8R8G8B8;
+	        
+			// check stencil buffer compatibility
+			if (!StencilBuffer)
+			{
+				tmp[i].AutoDepthStencilFormat = D3DFMT_D16;
+			}
+		}
+	}
+}
+
+bool CD3D9MDriver::initDirect3DInterface()
+{
+	if (!pID3D)
+	{
+		D3DLibrary = LoadLibrary( "d3d9.dll" );
+
+		if (!D3DLibrary)
+		{
+			os::Printer::log("Error, could not load d3d9.dll.", ELL_ERROR);
+			return false;
+		}
+
+		typedef IDirect3D9 * (__stdcall *D3DCREATETYPE)(UINT);
+		D3DCREATETYPE d3dCreate = (D3DCREATETYPE) GetProcAddress(D3DLibrary, "Direct3DCreate9");
+
+		if (!d3dCreate)
+		{
+			os::Printer::log("Error, could not get proc adress of Direct3DCreate9.", ELL_ERROR);
+			return false;
+		}
+
+		//just like pID3D = Direct3DCreate9(D3D_SDK_VERSION);
+		pID3D = (*d3dCreate)(D3D_SDK_VERSION);
+		
+
+		if (!pID3D)
+		{
+			os::Printer::log("Error initializing D3D.", ELL_ERROR);
+			return false;
+		}
+	}
+	return true;
+}
+
+//! initialises the Direct3D API for multihead support
+bool CD3D9MDriver::initDriver(const core::array<core::dimension2d<s32> >& screenSize, core::array<HWND> hwnd,
+								u32 bits, bool fullScreen, bool pureSoftware, bool highPrecisionFPU, bool vsync, bool antiAlias)
+{
+	HRESULT hr;
+	Fullscreen = fullScreen;
+	u32 idx = 0;
+
+	if(!initDirect3DInterface())
+		return false;
+
+	if(!findMultiHeadDevice())
+	{
+		os::Printer::log("No multihead adapters found! Try to start default adapter.", ELL_INFORMATION);
+		return false;
+	}
+
+	buildPresentParams(screenSize, hwnd, bits, vsync);
+
+
+	/*TODO enable anti aliasing*/
+	DWORD behaviorFlags = D3DCREATE_ADAPTERGROUP_DEVICE | 
+						  D3DCREATE_HARDWARE_VERTEXPROCESSING;
+
+	if (pureSoftware)
+	{
+		os::Printer::log("Was not able to create Direct3D9 software device with multimonitor mode.", ELL_ERROR);
+		return false;
+	}
+	else
+	{
+		core::array<HWND> hwnds;
+		for(idx = 0; idx < m_Device.iNumAdapters; ++idx)
+		{
+			for(u32 idy = 0; idy < m_Device.Adapters[idx].Ordinal; ++idy)
+			{
+				hwnds.push_back(hwnd[idy]);
+			}
+			hr = pID3D->CreateDevice(m_Device.Adapters[idx].AdapterID, D3DDEVTYPE_HAL,
+									hwnds[0], behaviorFlags, m_pPresentParams[idx], 
+									&pID3DDevice);
+
+			if(FAILED(hr))
+			{
+				os::Printer::log("Was not able to create Direct3D9 device with multimonitor support.", ELL_ERROR);
+				return false;
+			}
+			pID3DDevices.push_back(pID3DDevice);
+			m_pRenderTargets.push_back(LPDIRECT3DSURFACE9());//????
+			Materials.push_back(SMaterial());
+			LastMaterials.push_back(SMaterial());
+			ResetRenderStatess.push_back(false);
+			LastSetLights.push_back(-1);
+			LastVertexTypes.push_back((video::E_VERTEX_TYPE)-1);
+			Matricess.push_back(new core::matrix4[ETS_COUNT]);
+			hwnds.clear();
+		}
+	}
+	
+	bool devicesAvailable = true;
+	//now we check the created devices if there realy available
+	for(idx = 0; idx < pID3DDevices.size(); ++idx)
+	{
+		if (!pID3DDevices[idx])
+		{
+			os::Printer::log("Was not able to create DirectX9 device.", ELL_ERROR);
+			devicesAvailable = false;
+		}
+	}
+	if(!devicesAvailable)
+		return devicesAvailable;
+
+	reset();
+
+	for(idx = 0; idx < pID3DDevices.size(); ++idx)
+	{
+		Capss.push_back(_D3DCAPS9());
+		pID3DDevices[idx]->GetDeviceCaps(&Capss[Capss.size()-1]);
+		// disable stencilbuffer if necessary
+		if (StencilBuffer && 
+			(!(Capss[Capss.size()-1].StencilCaps & D3DSTENCILCAPS_DECRSAT) ||
+			!(Capss[Capss.size()-1].StencilCaps & D3DSTENCILCAPS_INCRSAT) ||
+			!(Capss[Capss.size()-1].StencilCaps & D3DSTENCILCAPS_KEEP)))
+		{
+			os::Printer::log("Device not able to use stencil buffer, disabling stencil buffer.", ELL_WARNING);
+			StencilBuffer = false;
+		}
+
+	}
+
+	// set exposed data
+	ExposedData.D3D9.D3D9 = pID3D;
+	ExposedData.D3D9.D3DDev9 = pID3DDevices[0];//we use here the first of the devices
+	ExposedData.D3D9.HWnd =  reinterpret_cast<s32>(hwnd[0]);
+
+	//pID3DDevice = pID3DDevices[0];
+
+	// create materials
+	createMaterialRenderers();
+
+	for(idx = 0; idx < pID3DDevices.size(); ++idx)
+	{
+		pID3DDevice = pID3DDevices[idx];
+		// set default vertex shader
+		setVertexShader(EVT_STANDARD);
+		// set fog mode
+		setFog(FogColor, LinearFog, FogStart, FogEnd, FogDensity, PixelFog, RangeFog);
+		ResetRenderStatess[idx] = true;
+
+		// enable antialiasing
+		if (antiAlias)
+			pID3DDevice->SetRenderState(D3DRS_MULTISAMPLEANTIALIAS, TRUE);
+
+		// set the renderstates
+		setRenderStates3DMode();
+
+		// set maximal anisotropy
+		pID3DDevice->SetSamplerState(0, D3DSAMP_MAXANISOTROPY, min(16, Capss[idx].MaxAnisotropy));
+		pID3DDevice->SetSamplerState(1, D3DSAMP_MAXANISOTROPY, min(16, Capss[idx].MaxAnisotropy));
+	}
+
+	pID3DDevice = pID3DDevices[0];
+	//setRenderStates3DMode();
+	// so far so good.
+	return true;
+
+}
+
+
+
+//! applications must call this method before performing any rendering. returns false if failed.
+bool CD3D9MDriver::beginScene(bool backBuffer, bool zBuffer, SColor color)
+{
+	CNullDriver::beginScene(backBuffer, zBuffer, color);
+	HRESULT hr;
+	u32 idx = 0;
+	
+	for(idx = 0; idx < pID3DDevices.size(); ++idx)
+	{
+		if(!pID3DDevices[idx])
+			return false;
+	
+
+		if (DeviceLost)
+		{
+			if(FAILED(hr = pID3DDevices[idx]->TestCooperativeLevel()))
+			{
+				if (hr == D3DERR_DEVICELOST)
+					return false;
+
+				if (hr == D3DERR_DEVICENOTRESET)
+					reset();
+				return false;
+			}
+		}
+	
+		BackBuffer = backBuffer;
+		ZBuffer = zBuffer;
+		Color = color;
+
+		if(m_pRenderTargets[idx] == NULL)
+		{
+			hr = pID3DDevices[idx]->GetRenderTarget( 0, &m_pRenderTargets[idx] );
+			if (FAILED(hr))
+			{
+				os::Printer::log("DirectX9 get render target failed.", ELL_WARNING);
+				return false;
+			}
+		}
+	
+		DWORD flags = 0;
+
+		if (backBuffer)
+			flags |= D3DCLEAR_TARGET;
+
+		if (zBuffer)
+			flags |= D3DCLEAR_ZBUFFER;
+
+		if (StencilBuffer)
+			flags |= D3DCLEAR_STENCIL;
+
+		hr = pID3DDevices[idx]->Clear( 0, NULL, flags, color.color, 1.0, 0);
+		if (FAILED(hr))
+			os::Printer::log("DIRECT3D9 clear failed.", ELL_WARNING);
+
+	}
+
+	pID3DDevice = pID3DDevices[0];
+
+	return true;
+}
+
+//! begins a part scene.
+bool CD3D9MDriver::beginPartScene()
+{
+	if (DeviceLost)
+		return false;
+
+	HRESULT hr = pID3DDevice->BeginScene();
+	if (FAILED(hr))
+	{
+		os::Printer::log("DirectX9 begin scene failed.", ELL_WARNING);
+		return false;
+	}
+	return true;
+}
+
+//! ends a part scene.
+bool CD3D9MDriver::endPartScene()
+{
+	if (DeviceLost)
+		return false;
+	HRESULT hr = pID3DDevice->EndScene();
+	if (FAILED(hr))
+	{
+		os::Printer::log("DirectX9 end scene failed.", ELL_WARNING);
+		return false;
+	}
+	return true;
+}
+
+
+//! applications must call this method after performing any rendering. returns false if failed.
+bool CD3D9MDriver::endScene( s32 windowId, core::rect<s32>* sourceRect )
+{
+	HRESULT hr;
+	if (DeviceLost)
+		return false;
+
+	CNullDriver::endScene();
+
+	for(u32 idx = 0; idx < pID3DDevices.size(); ++idx)
+	{
+		hr = pID3DDevices[idx]->SetRenderTarget( 0, m_pRenderTargets[idx] );
+		if(m_pRenderTargets[idx])
+		{
+			m_pRenderTargets[idx]->Release();
+			m_pRenderTargets[idx] = NULL;
+		}
+
+		RECT* srcRct = 0;
+		RECT sourceRectData;
+		if ( sourceRect )
+		{
+			srcRct = &sourceRectData;
+			sourceRectData.left = sourceRect->UpperLeftCorner.X;
+			sourceRectData.top = sourceRect->UpperLeftCorner.Y;
+			sourceRectData.right = sourceRect->LowerRightCorner.X;
+			sourceRectData.bottom = sourceRect->LowerRightCorner.Y;
+		}
+
+		hr = pID3DDevices[idx]->Present(srcRct, NULL, (HWND)windowId, NULL);
+		if (hr == D3DERR_DEVICELOST)
+		{
+			DeviceLost = true;
+			os::Printer::log("DirectX9 device lost.", ELL_WARNING);
+		}
+		else
+		if (FAILED(hr) && hr != D3DERR_INVALIDCALL)
+		{
+			os::Printer::log("DirectX9 present failed.", ELL_WARNING);
+			return false;
+		}
+	}
+	return true;
+
+	return true;
+}
+
+
+
+//! queries the features of the driver, returns true if feature is available
+bool CD3D9MDriver::queryFeature(E_VIDEO_DRIVER_FEATURE feature, s32 renderDevice)
+{
+	if(renderDevice > -1)
+	{
+		switch (feature)
+		{
+		case EVDF_MULTITEXTURE:
+		case EVDF_BILINEAR_FILTER:
+			return true;
+		case EVDF_RENDER_TO_TARGET:
+			return Capss[renderDevice].NumSimultaneousRTs > 0;
+		case EVDF_HARDWARE_TL:
+			return (Capss[renderDevice].DevCaps & D3DDEVCAPS_HWTRANSFORMANDLIGHT) != 0;
+		case EVDF_MIP_MAP:
+			return (Capss[renderDevice].TextureCaps & D3DPTEXTURECAPS_MIPMAP) != 0;
+		case EVDF_STENCIL_BUFFER:
+			return StencilBuffer &&  Capss[renderDevice].StencilCaps;
+		case EVDF_VERTEX_SHADER_1_1:
+			return Capss[renderDevice].VertexShaderVersion >= D3DVS_VERSION(1,1);
+		case EVDF_VERTEX_SHADER_2_0:
+			return Capss[renderDevice].VertexShaderVersion >= D3DVS_VERSION(2,0);
+		case EVDF_VERTEX_SHADER_3_0:
+			return Capss[renderDevice].VertexShaderVersion >= D3DVS_VERSION(3,0);
+		case EVDF_PIXEL_SHADER_1_1:
+			return Capss[renderDevice].PixelShaderVersion >= D3DPS_VERSION(1,1);
+		case EVDF_PIXEL_SHADER_1_2:
+			return Capss[renderDevice].PixelShaderVersion >= D3DPS_VERSION(1,2);
+		case EVDF_PIXEL_SHADER_1_3:
+			return Capss[renderDevice].PixelShaderVersion >= D3DPS_VERSION(1,3);
+		case EVDF_PIXEL_SHADER_1_4:
+			return Capss[renderDevice].PixelShaderVersion >= D3DPS_VERSION(1,4);
+		case EVDF_PIXEL_SHADER_2_0:
+			return Capss[renderDevice].PixelShaderVersion >= D3DPS_VERSION(2,0);
+		case EVDF_PIXEL_SHADER_3_0:
+			return Capss[renderDevice].PixelShaderVersion >= D3DPS_VERSION(3,0);
+		case EVDF_HLSL:
+			return Capss[renderDevice].VertexShaderVersion >= D3DVS_VERSION(1,1);
+		case EVDF_TEXTURE_NPOT:
+			return (Capss[renderDevice].TextureCaps & D3DPTEXTURECAPS_POW2) == 0;
+		default:
+			return false;
+		};
+	}
+	bool result = true;
+	for(u32 idx = 0; idx < Capss.size(); ++idx)
+	{
+		switch (feature)
+		{
+		case EVDF_MULTITEXTURE:
+		case EVDF_BILINEAR_FILTER:
+			result = true;
+			break;
+		case EVDF_RENDER_TO_TARGET:
+			result = Capss[idx].NumSimultaneousRTs > 0;
+			break;
+		case EVDF_HARDWARE_TL:
+			result = (Capss[idx].DevCaps & D3DDEVCAPS_HWTRANSFORMANDLIGHT) != 0;
+			break;
+		case EVDF_MIP_MAP:
+			result = (Capss[idx].TextureCaps & D3DPTEXTURECAPS_MIPMAP) != 0;
+			break;
+		case EVDF_STENCIL_BUFFER:
+			result = StencilBuffer &&  Capss[idx].StencilCaps;
+			break;
+		case EVDF_VERTEX_SHADER_1_1:
+			result = Capss[idx].VertexShaderVersion >= D3DVS_VERSION(1,1);
+			break;
+		case EVDF_VERTEX_SHADER_2_0:
+			result = Capss[idx].VertexShaderVersion >= D3DVS_VERSION(2,0);
+			break;
+		case EVDF_VERTEX_SHADER_3_0:
+			result = Capss[idx].VertexShaderVersion >= D3DVS_VERSION(3,0);
+			break;
+		case EVDF_PIXEL_SHADER_1_1:
+			result = Capss[idx].PixelShaderVersion >= D3DPS_VERSION(1,1);
+			break;
+		case EVDF_PIXEL_SHADER_1_2:
+			result = Capss[idx].PixelShaderVersion >= D3DPS_VERSION(1,2);
+			break;
+		case EVDF_PIXEL_SHADER_1_3:
+			result = Capss[idx].PixelShaderVersion >= D3DPS_VERSION(1,3);
+			break;
+		case EVDF_PIXEL_SHADER_1_4:
+			result = Capss[idx].PixelShaderVersion >= D3DPS_VERSION(1,4);
+			break;
+		case EVDF_PIXEL_SHADER_2_0:
+			result = Capss[idx].PixelShaderVersion >= D3DPS_VERSION(2,0);
+			break;
+		case EVDF_PIXEL_SHADER_3_0:
+			result = Capss[idx].PixelShaderVersion >= D3DPS_VERSION(3,0);
+			break;
+		case EVDF_HLSL:
+			result = Capss[idx].VertexShaderVersion >= D3DVS_VERSION(1,1);
+			break;
+		case EVDF_TEXTURE_NPOT:
+			result = (Capss[idx].TextureCaps & D3DPTEXTURECAPS_POW2) == 0;
+			break;
+		default:
+			result = false;
+		};
+		if(!result)
+			return result;
+	}
+	return result;
+}
+
+
+
+//! sets transformation
+void CD3D9MDriver::setTransform(E_TRANSFORMATION_STATE state, const core::matrix4& mat)
+{
+	Transformation3DChanged = true;
+
+	switch(state)
+	{
+	case ETS_VIEW:
+		pID3DDevice->SetTransform(D3DTS_VIEW, (D3DMATRIX*)((void*)&mat));
+		break;
+	case ETS_WORLD:
+		pID3DDevice->SetTransform(D3DTS_WORLD, (D3DMATRIX*)((void*)&mat));
+		break;
+	case ETS_PROJECTION:
+		pID3DDevice->SetTransform( D3DTS_PROJECTION, (D3DMATRIX*)((void*)&mat));
+		break;
+	}
+
+	Matricess[m_renderAdapter][state] = mat;
+}
+
+
+
+//! sets the current Texture
+bool CD3D9MDriver::setTexture(s32 stage, video::ITexture* texture)
+{
+	if (CurrentTexture[stage] == texture)
+		return true;
+
+	if (texture && texture->getDriverType() != EDT_DIRECT3D9)
+	{
+		os::Printer::log("Fatal Error: Tried to set a texture not owned by this driver.", ELL_ERROR);
+		return false;
+	}
+
+	if (CurrentTexture[stage])
+		CurrentTexture[stage]->drop();
+
+	CurrentTexture[stage] = texture;
+
+	if (!texture)
+		pID3DDevice->SetTexture(stage, 0);
+	else
+	{
+		pID3DDevice->SetTexture(stage, ((CD3D9Texture*)texture)->getDX9Texture(m_renderAdapter));
+		texture->grab();
+		pID3DDevice->SetTextureStageState( stage, D3DTSS_TEXTURETRANSFORMFLAGS, D3DTTFF_COUNT2 );
+		pID3DDevice->SetTransform((D3DTRANSFORMSTATETYPE)(D3DTS_TEXTURE0+stage), (D3DMATRIX*)((void*)&texture->getTransformation()));
+	}
+	return true;
+}
+
+
+
+//! sets a material
+void CD3D9MDriver::setMaterial(const SMaterial& material)
+{
+	Materials[m_renderAdapter] = material;
+
+	for (s32 i=0; i<MATERIAL_MAX_TEXTURES; ++i)
+		setTexture(i, Materials[m_renderAdapter].Textures[i]);
+}
+
+
+
+//! returns a device dependent texture from a software surface (IImage)
+video::ITexture* CD3D9MDriver::createDeviceDependentTexture(IImage* surface, const char* name)
+{
+	return new CD3D9Texture(surface, this, pID3DDevices, TextureCreationFlags, name);
+}
+
+
+
+//! Enables or disables a texture creation flag.
+void CD3D9MDriver::setTextureCreationFlag(E_TEXTURE_CREATION_FLAG flag, bool enabled)
+{
+	if (flag == video::ETCF_CREATE_MIP_MAPS && !queryFeature(EVDF_MIP_MAP))
+		enabled = false;
+
+	CNullDriver::setTextureCreationFlag(flag, enabled);
+}
+
+
+
+//! sets a render target
+bool CD3D9MDriver::setRenderTarget(video::ITexture* texture,
+			bool clearBackBuffer, bool clearZBuffer,
+			SColor color)
+{
+	// check for right driver type
+
+	if (texture && texture->getDriverType() != EDT_DIRECT3D9)
+	{
+		os::Printer::log("Fatal Error: Tried to set a texture not owned by this driver.", ELL_ERROR);
+		return false;
+	}
+
+	// check for valid render target
+
+	CD3D9Texture* tex = (CD3D9Texture*)texture;
+
+	if (texture && !tex->isRenderTarget())
+	{
+		os::Printer::log("Fatal Error: Tried to set a non render target texture as render target.", ELL_ERROR);
+		return false;
+	}
+
+	if (texture && (tex->getSize().Width > ScreenSize.Width ||
+		tex->getSize().Height > ScreenSize.Height ))
+	{
+		os::Printer::log("Error: Tried to set a render target texture which is bigger than the screen.", ELL_ERROR);
+		return false;
+	}
+
+	// check if we should set the previous RT back
+
+	bool ret = true;
+
+	if (tex == 0)
+	{
+		if (PrevRenderTarget)
+		{
+			if (FAILED(pID3DDevice->SetRenderTarget(0, PrevRenderTarget)))
+			{
+				os::Printer::log("Error: Could not set back to previous render target.", ELL_ERROR);
+				ret = false;
+			}
+
+			CurrentRendertargetSize = core::dimension2d<s32>(0,0);
+			PrevRenderTarget->Release();
+			PrevRenderTarget = 0;
+		}
+	}
+	else
+	{
+		// we want to set a new target. so do this.
+
+		// store previous target
+
+		if (!PrevRenderTarget)
+			if (FAILED(pID3DDevice->GetRenderTarget(0, &PrevRenderTarget)))
+			{
+				os::Printer::log("Could not get previous render target.", ELL_ERROR);
+				return false;
+			}
+
+		// set new render target
+
+			if (FAILED(pID3DDevice->SetRenderTarget(0, tex->getRenderTargetSurface(m_renderAdapter))))
+		{
+			os::Printer::log("Error: Could not set render target.", ELL_ERROR);
+			return false;
+		}
+
+		CurrentRendertargetSize = tex->getSize();
+	}
+
+	if (clearBackBuffer || clearZBuffer)
+	{
+		DWORD flags = 0;
+
+		if (clearBackBuffer)
+			flags |= D3DCLEAR_TARGET;
+
+		if (clearZBuffer)
+			flags |= D3DCLEAR_ZBUFFER;
+
+		pID3DDevice->Clear(0, NULL, flags, color.color, 1.0f, 0);
+	}
+
+	return ret;
+}
+
+
+
+//! sets a viewport
+void CD3D9MDriver::setViewPort(const core::rect<s32>& area)
+{
+	HRESULT hr;
+	core::rect<s32> vp = area;
+	s32 curRenderAdapter = -1;
+	u32 ordinal = 0;
+	s32 adapterAdd = 0;
+	s32 monitorCount = 0;
+
+	//if already exist, then clear
+	if(m_pBackBuffer)
+	{
+		m_pBackBuffer->Release();
+		m_pBackBuffer = NULL;
+	}
+    if(m_pSwapChain)
+	{
+		m_pSwapChain->Release();
+		m_pSwapChain = NULL;
+	}
+	
+	monitorCount = area.UpperLeftCorner.X / ScreenSize.Width;
+	
+	for(s32 idx = 0; idx < (s32)m_Device.iNumAdapters; ++idx)
+	{
+		for(u32 idy = 0; idy < m_Device.Adapters[idx].Ordinal; ++idy)
+		{
+			if(monitorCount == (idx+idy+adapterAdd))
+			{
+				curRenderAdapter = idx;
+				ordinal = idy;
+				break;
+			}
+		}
+		adapterAdd++;
+		if(curRenderAdapter > -1)
+			break;
+	}
+	pID3DDevice = pID3DDevices[curRenderAdapter];
+	m_renderAdapter = curRenderAdapter;
+
+	if(monitorCount > 0)
+	{
+		vp = core::rect<s32>((area.UpperLeftCorner.X / monitorCount - ScreenSize.Width), 
+								area.UpperLeftCorner.Y, (area.LowerRightCorner.X / monitorCount), area.getHeight());
+
+	}
+
+	u32 numSwapChains = pID3DDevice->GetNumberOfSwapChains();
+
+	if(ordinal > numSwapChains)
+	{
+		char tmp[255];
+		sprintf(tmp, "DirectX9 multihead error! More adapter supposed as available. adapter: %d  ordinal: %d chain: %d", curRenderAdapter, ordinal, numSwapChains);
+		os::Printer::log(tmp, ELL_WARNING);
+		return;
+	}
+	hr = pID3DDevice->GetSwapChain( ordinal, &m_pSwapChain );
+	if (FAILED(hr))
+	{
+		os::Printer::log("DirectX9 multihead error! Get swap chain failed.", ELL_WARNING);
+		return;
+	}
+	hr = m_pSwapChain->GetBackBuffer( 0, D3DBACKBUFFER_TYPE_MONO, &m_pBackBuffer );
+	if (FAILED(hr))
+	{
+		os::Printer::log("DirectX9 multihead error!  Get back buffer failed.", ELL_WARNING);
+		return;
+	}
+	hr = pID3DDevice->SetRenderTarget( 0, m_pBackBuffer );
+	if (FAILED(hr))
+	{
+		os::Printer::log("DirectX9 multihead error! Set render target failed.", ELL_WARNING);
+		return;
+	}
+	BackBuffer = true;
+
+	core::rect<s32> rendert(0,0, ScreenSize.Width, ScreenSize.Height);
+	vp.clipAgainst(rendert);
+
+	D3DVIEWPORT9 viewPort;
+	viewPort.X = vp.UpperLeftCorner.X;
+	viewPort.Y = vp.UpperLeftCorner.Y;
+	viewPort.Width = vp.getWidth();
+	viewPort.Height = vp.getHeight();
+	viewPort.MinZ = 0.0f;
+	viewPort.MaxZ = 1.0f;
+
+	hr = D3DERR_INVALIDCALL;
+	if (vp.getHeight()>0 && vp.getWidth()>0)
+		hr = pID3DDevice->SetViewport(&viewPort);
+
+	if (FAILED(hr))
+		os::Printer::log("Failed setting the viewport.", ELL_WARNING);
+
+	DWORD flags = 0;
+
+	if (BackBuffer)
+		flags |= D3DCLEAR_TARGET;
+
+	if (ZBuffer)
+		flags |= D3DCLEAR_ZBUFFER;
+
+	if (StencilBuffer)
+		flags |= D3DCLEAR_STENCIL;
+
+	hr = pID3DDevice->Clear( 0, NULL, flags, Color.color, 1.0, 0);
+	if (FAILED(hr))
+		os::Printer::log("DirectX9 clear viewport failed.", ELL_WARNING);
+
+	ViewPort = vp;
+}
+
+
+
+//! gets the area of the current viewport
+const core::rect<s32>& CD3D9MDriver::getViewPort() const
+{
+	return ViewPort;
+}
+
+
+
+//! draws a vertex primitive list
+void CD3D9MDriver::drawVertexPrimitiveList(const void* vertices, s32 vertexCount, const u32* indexList, s32 primitiveCount, E_VERTEX_TYPE vType, scene::E_PRIMITIVE_TYPE pType)
+{
+	if (!checkPrimitiveCount(primitiveCount))
+		return;
+
+	CNullDriver::drawVertexPrimitiveList(vertices, vertexCount, indexList, primitiveCount, vType, pType);
+
+	if (!vertexCount || !primitiveCount)
+		return;
+
+	if(!beginPartScene())
+	{
+		os::Printer::log("DirectX9 beginPartScene failed.", ELL_WARNING);
+		return;
+	}
+	setVertexShader(vType);
+
+	size_t stride=0;
+	switch (vType)
+	{
+		case EVT_STANDARD:
+			stride=sizeof(S3DVertex);
+			break;
+		case EVT_2TCOORDS:
+			stride=sizeof(S3DVertex2TCoords);
+			break;
+		case EVT_TANGENTS:
+			stride=sizeof(S3DVertexTangents);
+			break;
+	}
+	if (setRenderStates3DMode())
+	{
+		switch (pType)
+		{
+			case scene::EPT_POINTS:
+				pID3DDevice->DrawIndexedPrimitiveUP(D3DPT_POINTLIST, 0, vertexCount,
+					primitiveCount, indexList, D3DFMT_INDEX32, vertices, stride);
+				break;
+			case scene::EPT_LINE_STRIP:
+				pID3DDevice->DrawIndexedPrimitiveUP(D3DPT_LINESTRIP, 0, vertexCount,
+					primitiveCount, indexList, D3DFMT_INDEX32, vertices, stride);
+				break;
+			case scene::EPT_LINE_LOOP:
+			{
+				pID3DDevice->DrawIndexedPrimitiveUP(D3DPT_LINESTRIP, 0, vertexCount,
+					primitiveCount, indexList, D3DFMT_INDEX32, vertices, stride);
+				u16 tmpIndices[] = {0, primitiveCount};
+				pID3DDevice->DrawIndexedPrimitiveUP(D3DPT_LINELIST, 0, vertexCount,
+					1, tmpIndices, D3DFMT_INDEX16, vertices, stride);
+			}
+				break;
+			case scene::EPT_LINES:
+				pID3DDevice->DrawIndexedPrimitiveUP(D3DPT_LINELIST, 0, vertexCount,
+					primitiveCount, indexList, D3DFMT_INDEX32, vertices, stride);
+				break;
+			case scene::EPT_TRIANGLE_STRIP:
+				pID3DDevice->DrawIndexedPrimitiveUP(D3DPT_TRIANGLESTRIP, 0, vertexCount,
+					primitiveCount, indexList, D3DFMT_INDEX32, vertices, stride);
+				break;
+			case scene::EPT_TRIANGLE_FAN:
+				pID3DDevice->DrawIndexedPrimitiveUP(D3DPT_TRIANGLEFAN, 0, vertexCount,
+					primitiveCount, indexList, D3DFMT_INDEX32, vertices, stride);
+				break;
+			case scene::EPT_TRIANGLES:
+				pID3DDevice->DrawIndexedPrimitiveUP(D3DPT_TRIANGLELIST, 0, vertexCount,
+					primitiveCount, indexList, D3DFMT_INDEX32, vertices, stride);
+				break;
+		}
+	}
+	endPartScene();
+}
+
+
+
+void CD3D9MDriver::draw2DImage(video::ITexture* texture, const core::rect<s32>& destRect,
+		const core::rect<s32>& sourceRect, const core::rect<s32>* clipRect,
+		video::SColor* colors, bool useAlphaChannelOfTexture)
+{
+	if(!texture)
+		return;
+
+	core::rect<s32> trgRect(destRect);
+
+	const core::dimension2d<s32>& ss = texture->getOriginalSize();
+	f32 ssw=1.0f/ss.Width;
+	f32 ssh=1.0f/ss.Height;
+
+	core::rect<f32> tcoords;
+	tcoords.UpperLeftCorner.X = (((f32)sourceRect.UpperLeftCorner.X)+0.5f) * ssw ;
+	tcoords.UpperLeftCorner.Y = (((f32)sourceRect.UpperLeftCorner.Y)+0.5f) * ssh;
+	tcoords.LowerRightCorner.X = (((f32)sourceRect.UpperLeftCorner.X +0.5f + (f32)sourceRect.getWidth())) * ssw;
+	tcoords.LowerRightCorner.Y = (((f32)sourceRect.UpperLeftCorner.Y +0.5f + (f32)sourceRect.getHeight())) * ssh;
+
+	core::dimension2d<s32> renderTargetSize = getCurrentRenderTargetSize();
+
+	s32 xPlus = -(renderTargetSize.Width>>1);
+	f32 xFact = 1.0f / (renderTargetSize.Width>>1);
+
+	s32 yPlus = renderTargetSize.Height-(renderTargetSize.Height>>1);
+	f32 yFact = 1.0f / (renderTargetSize.Height>>1);
+
+	core::rect<f32> npos;
+	npos.UpperLeftCorner.X = (f32)(trgRect.UpperLeftCorner.X+xPlus+0.5f) * xFact;
+	npos.UpperLeftCorner.Y = (f32)(yPlus-trgRect.UpperLeftCorner.Y+0.5f) * yFact;
+	npos.LowerRightCorner.X = (f32)(trgRect.LowerRightCorner.X+xPlus+0.5f) * xFact;
+	npos.LowerRightCorner.Y = (f32)(yPlus-trgRect.LowerRightCorner.Y+0.5f) * yFact;
+
+	video::SColor temp[4] =
+	{
+		0xFFFFFFFF,
+		0xFFFFFFFF,
+		0xFFFFFFFF,
+		0xFFFFFFFF
+	};
+
+	video::SColor* useColor = colors ? colors : temp;
+
+	S3DVertex vtx[4]; // clock wise
+	vtx[0] = S3DVertex(npos.UpperLeftCorner.X, npos.UpperLeftCorner.Y , 0.0f, 0.0f, 0.0f, 0.0f, useColor[0], tcoords.UpperLeftCorner.X, tcoords.UpperLeftCorner.Y);
+	vtx[1] = S3DVertex(npos.LowerRightCorner.X, npos.UpperLeftCorner.Y , 0.0f, 0.0f, 0.0f, 0.0f, useColor[3], tcoords.LowerRightCorner.X, tcoords.UpperLeftCorner.Y);
+	vtx[2] = S3DVertex(npos.LowerRightCorner.X, npos.LowerRightCorner.Y, 0.0f, 0.0f, 0.0f, 0.0f, useColor[2], tcoords.LowerRightCorner.X, tcoords.LowerRightCorner.Y);
+	vtx[3] = S3DVertex(npos.UpperLeftCorner.X, npos.LowerRightCorner.Y, 0.0f, 0.0f, 0.0f, 0.0f, useColor[1], tcoords.UpperLeftCorner.X, tcoords.LowerRightCorner.Y);
+
+	s16 indices[6] = {0,1,2,0,2,3};
+
+	if(!beginPartScene())
+	{
+		os::Printer::log("DirectX9 beginPartScene failed.", ELL_WARNING);
+		return;
+	}
+	setRenderStates2DMode(useColor[0].getAlpha()<255 || useColor[1].getAlpha()<255 || useColor[2].getAlpha()<255 || useColor[3].getAlpha()<255, true, useAlphaChannelOfTexture);
+
+	setTexture(0, texture);
+
+	setVertexShader(EVT_STANDARD);
+
+	pID3DDevice->DrawIndexedPrimitiveUP(D3DPT_TRIANGLELIST, 0, 4, 2, &indices[0],
+				D3DFMT_INDEX16,&vtx[0], sizeof(S3DVertex));
+
+	endPartScene();
+}
+
+
+
+//! draws a 2d image, using a color and the alpha channel of the texture if
+//! desired. The image is drawn at pos and clipped against clipRect (if != 0).
+void CD3D9MDriver::draw2DImage(video::ITexture* texture,
+				const core::position2d<s32>& pos,
+				const core::rect<s32>& sourceRect,
+				const core::rect<s32>* clipRect, SColor color,
+				bool useAlphaChannelOfTexture)
+{
+	if (!texture)
+		return;
+
+	if (!sourceRect.isValid())
+		return;
+
+	if (!setTexture(0, texture))
+		return;
+
+	core::position2d<s32> targetPos = pos;
+	core::position2d<s32> sourcePos = sourceRect.UpperLeftCorner;
+	core::dimension2d<s32> sourceSize(sourceRect.getSize());
+
+	core::dimension2d<s32> renderTargetSize = getCurrentRenderTargetSize();
+
+	if (clipRect)
+	{
+		if (targetPos.X < clipRect->UpperLeftCorner.X)
+		{
+			sourceSize.Width += targetPos.X - clipRect->UpperLeftCorner.X;
+			if (sourceSize.Width <= 0)
+				return;
+
+			sourcePos.X -= targetPos.X - clipRect->UpperLeftCorner.X;
+			targetPos.X = clipRect->UpperLeftCorner.X;
+		}
+
+		if (targetPos.X + sourceSize.Width > clipRect->LowerRightCorner.X)
+		{
+			sourceSize.Width -= (targetPos.X + sourceSize.Width) - clipRect->LowerRightCorner.X;
+			if (sourceSize.Width <= 0)
+				return;
+		}
+
+		if (targetPos.Y < clipRect->UpperLeftCorner.Y)
+		{
+			sourceSize.Height += targetPos.Y - clipRect->UpperLeftCorner.Y;
+			if (sourceSize.Height <= 0)
+				return;
+
+			sourcePos.Y -= targetPos.Y - clipRect->UpperLeftCorner.Y;
+			targetPos.Y = clipRect->UpperLeftCorner.Y;
+		}
+
+		if (targetPos.Y + sourceSize.Height > clipRect->LowerRightCorner.Y)
+		{
+			sourceSize.Height -= (targetPos.Y + sourceSize.Height) - clipRect->LowerRightCorner.Y;
+			if (sourceSize.Height <= 0)
+				return;
+		}
+	}
+
+	// clip these coordinates
+
+	if (targetPos.X<0)
+	{
+		sourceSize.Width += targetPos.X;
+		if (sourceSize.Width <= 0)
+			return;
+
+		sourcePos.X -= targetPos.X;
+		targetPos.X = 0;
+	}
+
+	if (targetPos.X + sourceSize.Width > renderTargetSize.Width)
+	{
+		sourceSize.Width -= (targetPos.X + sourceSize.Width) - renderTargetSize.Width;
+		if (sourceSize.Width <= 0)
+			return;
+	}
+
+	if (targetPos.Y<0)
+	{
+		sourceSize.Height += targetPos.Y;
+		if (sourceSize.Height <= 0)
+			return;
+
+		sourcePos.Y -= targetPos.Y;
+		targetPos.Y = 0;
+	}
+
+	if (targetPos.Y + sourceSize.Height > renderTargetSize.Height)
+	{
+		sourceSize.Height -= (targetPos.Y + sourceSize.Height) - renderTargetSize.Height;
+		if (sourceSize.Height <= 0)
+			return;
+	}
+
+	// ok, we've clipped everything.
+	// now draw it.
+
+	f32 xPlus = - renderTargetSize.Width / 2.f;
+	f32 xFact = 1.0f / (renderTargetSize.Width / 2.f);
+
+	f32 yPlus = renderTargetSize.Height-(renderTargetSize.Height / 2.f);
+	f32 yFact = 1.0f / (renderTargetSize.Height / 2.f);
+
+	const core::dimension2d<s32>& sourceSurfaceSize = texture->getOriginalSize();
+	core::rect<f32> tcoords;
+	tcoords.UpperLeftCorner.X = (((f32)sourcePos.X)+0.5f) / texture->getOriginalSize().Width ;
+	tcoords.UpperLeftCorner.Y = (((f32)sourcePos.Y)+0.5f) / texture->getOriginalSize().Height;
+	tcoords.LowerRightCorner.X = (((f32)sourcePos.X +0.5f + (f32)sourceSize.Width)) / texture->getOriginalSize().Width;
+	tcoords.LowerRightCorner.Y = (((f32)sourcePos.Y +0.5f + (f32)sourceSize.Height)) / texture->getOriginalSize().Height;
+
+	core::rect<s32> poss(targetPos, sourceSize);
+
+	if(!beginPartScene())
+	{
+		os::Printer::log("DirectX9 beginPartScene failed.", ELL_WARNING);
+		return;
+	}
+	setRenderStates2DMode(color.getAlpha()<255, true, useAlphaChannelOfTexture);
+
+	S3DVertex vtx[4];
+	vtx[0] = S3DVertex((f32)(poss.UpperLeftCorner.X+xPlus) * xFact, (f32)(yPlus-poss.UpperLeftCorner.Y ) * yFact , 0.0f, 0.0f, 0.0f, 0.0f, color, tcoords.UpperLeftCorner.X, tcoords.UpperLeftCorner.Y);
+	vtx[1] = S3DVertex((f32)(poss.LowerRightCorner.X+xPlus) * xFact, (f32)(yPlus- poss.UpperLeftCorner.Y) * yFact, 0.0f, 0.0f, 0.0f, 0.0f, color, tcoords.LowerRightCorner.X, tcoords.UpperLeftCorner.Y);
+	vtx[2] = S3DVertex((f32)(poss.LowerRightCorner.X+xPlus) * xFact, (f32)(yPlus-poss.LowerRightCorner.Y) * yFact, 0.0f, 0.0f, 0.0f, 0.0f, color, tcoords.LowerRightCorner.X, tcoords.LowerRightCorner.Y);
+	vtx[3] = S3DVertex((f32)(poss.UpperLeftCorner.X+xPlus) * xFact, (f32)(yPlus-poss.LowerRightCorner.Y) * yFact, 0.0f, 0.0f, 0.0f, 0.0f, color, tcoords.UpperLeftCorner.X, tcoords.LowerRightCorner.Y);
+
+	s16 indices[6] = {0,1,2,0,2,3};
+
+	setVertexShader(EVT_STANDARD);
+
+	pID3DDevice->DrawIndexedPrimitiveUP(D3DPT_TRIANGLELIST, 0, 4, 2, &indices[0],
+										D3DFMT_INDEX16,&vtx[0],	sizeof(S3DVertex));
+	endPartScene();
+}
+
+
+
+//!Draws a 2d rectangle with a gradient.
+void CD3D9MDriver::draw2DRectangle(const core::rect<s32>& position,
+	SColor colorLeftUp, SColor colorRightUp, SColor colorLeftDown, SColor colorRightDown,
+	const core::rect<s32>* clip)
+{
+	core::rect<s32> pos(position);
+
+	if (clip)
+		pos.clipAgainst(*clip);
+
+	if (!pos.isValid())
+		return;
+
+	const core::dimension2d<s32>& renderTargetSize = getCurrentRenderTargetSize();
+
+	s32 xPlus = -(renderTargetSize.Width>>1);
+	f32 xFact = 1.0f / (renderTargetSize.Width>>1);
+
+	s32 yPlus = renderTargetSize.Height-(renderTargetSize.Height>>1);
+	f32 yFact = 1.0f / (renderTargetSize.Height>>1);
+
+	S3DVertex vtx[4];
+	vtx[0] = S3DVertex((f32)(pos.UpperLeftCorner.X+xPlus) * xFact, (f32)(yPlus-pos.UpperLeftCorner.Y) * yFact , 0.0f, 0.0f, 0.0f, 0.0f, colorLeftUp, 0.0f, 0.0f);
+	vtx[1] = S3DVertex((f32)(pos.LowerRightCorner.X+xPlus) * xFact, (f32)(yPlus- pos.UpperLeftCorner.Y) * yFact, 0.0f, 0.0f, 0.0f, 0.0f, colorRightUp, 0.0f, 1.0f);
+	vtx[2] = S3DVertex((f32)(pos.LowerRightCorner.X+xPlus) * xFact, (f32)(yPlus-pos.LowerRightCorner.Y) * yFact, 0.0f, 0.0f, 0.0f, 0.0f, colorRightDown, 1.0f, 0.0f);
+	vtx[3] = S3DVertex((f32)(pos.UpperLeftCorner.X+xPlus) * xFact, (f32)(yPlus-pos.LowerRightCorner.Y) * yFact, 0.0f, 0.0f, 0.0f, 0.0f, colorLeftDown, 1.0f, 1.0f);
+
+	s16 indices[6] = {0,1,2,0,2,3};
+
+	if(!beginPartScene())
+	{
+		os::Printer::log("DirectX9 beginPartScene failed.", ELL_WARNING);
+		return;
+	}
+	setRenderStates2DMode(
+		colorLeftUp.getAlpha() < 255 ||
+		colorRightUp.getAlpha() < 255 ||
+		colorLeftDown.getAlpha() < 255 ||
+		colorRightDown.getAlpha() < 255, false, false);
+
+	setTexture(0,0);
+
+	setVertexShader(EVT_STANDARD);
+
+	pID3DDevice->DrawIndexedPrimitiveUP(D3DPT_TRIANGLELIST, 0, 4, 2, &indices[0],
+											D3DFMT_INDEX16, &vtx[0], sizeof(S3DVertex));
+	endPartScene();
+}
+
+
+
+//! Draws a 2d line.
+void CD3D9MDriver::draw2DLine(const core::position2d<s32>& start,
+				const core::position2d<s32>& end,
+				SColor color)
+{
+	// thanks to Vash TheStampede who sent in his implementation
+
+	const core::dimension2d<s32>& renderTargetSize = getCurrentRenderTargetSize();
+	const s32 xPlus = -(renderTargetSize.Width>>1);
+	const f32 xFact = 1.0f / (renderTargetSize.Width>>1);
+
+	const s32 yPlus = renderTargetSize.Height-(renderTargetSize.Height>>1);
+	const f32 yFact = 1.0f / (renderTargetSize.Height>>1);
+
+	S3DVertex vtx[2];
+	vtx[0] = S3DVertex((f32)(start.X + xPlus) * xFact,
+						(f32)(yPlus - start.Y) * yFact,
+						0.0f, // z
+						0.0f, 0.0f, 0.0f, // normal
+						color,
+						0.0f, 0.0f); // texture
+
+	vtx[1] = S3DVertex((f32)(end.X+xPlus) * xFact,
+						(f32)(yPlus- end.Y) * yFact,
+						0.0f,
+						0.0f, 0.0f, 0.0f,
+						color,
+						0.0f, 0.0f);
+
+	if(!beginPartScene())
+	{
+		os::Printer::log("DirectX9 beginPartScene failed.", ELL_WARNING);
+		return;
+	}
+	setRenderStates2DMode(color.getAlpha() < 255, false, false);
+	setTexture(0,0);
+
+	setVertexShader(EVT_STANDARD);
+
+	pID3DDevice->DrawPrimitiveUP(D3DPT_LINELIST, 1,
+					&vtx[0], sizeof(S3DVertex) );
+
+	endPartScene();
+}
+
+
+
+//! sets right vertex shader
+void CD3D9MDriver::setVertexShader(E_VERTEX_TYPE newType)
+{
+	if (newType != LastVertexTypes[m_renderAdapter])
+	{
+		LastVertexTypes[m_renderAdapter] = newType;
+		HRESULT hr = 0;
+
+		switch(newType)
+		{
+		case EVT_STANDARD:
+			hr = pID3DDevice->SetFVF(D3DFVF_XYZ | D3DFVF_NORMAL | D3DFVF_DIFFUSE | D3DFVF_TEX1);
+			break;
+		case EVT_2TCOORDS:
+			hr = pID3DDevice->SetFVF(D3DFVF_XYZ | D3DFVF_NORMAL | D3DFVF_DIFFUSE | D3DFVF_TEX2);
+			break;
+		case EVT_TANGENTS:
+			hr = pID3DDevice->SetFVF(D3DFVF_XYZ | D3DFVF_NORMAL | D3DFVF_DIFFUSE | D3DFVF_TEX3 |
+				D3DFVF_TEXCOORDSIZE2(0) | // real texture coord
+				D3DFVF_TEXCOORDSIZE3(1) | // misuse texture coord 2 for tangent
+				D3DFVF_TEXCOORDSIZE3(2)   // misuse texture coord 3 for binormal
+				);
+			break;
+		}
+
+		if (FAILED(hr))
+		{
+			os::Printer::log("Could not set vertex Shader.", ELL_ERROR);
+			return;
+		}
+	}
+}
+
+
+
+//! sets the needed renderstates
+bool CD3D9MDriver::setRenderStates3DMode()
+{
+	if (!pID3DDevice)
+		return false;
+
+	if (CurrentRenderMode != ERM_3D)
+	{
+		// switch back the matrices
+		pID3DDevice->SetTransform(D3DTS_VIEW, (D3DMATRIX*)((void*)&Matricess[m_renderAdapter][ETS_VIEW]));
+		pID3DDevice->SetTransform(D3DTS_WORLD, (D3DMATRIX*)((void*)&Matricess[m_renderAdapter][ETS_WORLD]));
+		pID3DDevice->SetTransform(D3DTS_PROJECTION, (D3DMATRIX*)((void*)&Matricess[m_renderAdapter][ETS_PROJECTION]));
+
+		pID3DDevice->SetRenderState(D3DRS_STENCILENABLE, FALSE);
+
+		ResetRenderStatess[m_renderAdapter] = true;
+	}
+
+	if (ResetRenderStatess[m_renderAdapter] || LastMaterials[m_renderAdapter] != Materials[m_renderAdapter])
+	{
+		// unset old material
+
+		if (CurrentRenderMode == ERM_3D &&
+			LastMaterials[m_renderAdapter].MaterialType != Materials[m_renderAdapter].MaterialType &&
+			LastMaterials[m_renderAdapter].MaterialType >= 0 && LastMaterials[m_renderAdapter].MaterialType < (s32)MaterialRenderers.size())
+		{
+			MaterialRenderers[LastMaterials[m_renderAdapter].MaterialType].Renderer->setRenderDevice(m_renderAdapter);
+			MaterialRenderers[LastMaterials[m_renderAdapter].MaterialType].Renderer->OnUnsetMaterial();
+		}
+
+		// set new material.
+
+		if (Materials[m_renderAdapter].MaterialType >= 0 && Materials[m_renderAdapter].MaterialType < (s32)MaterialRenderers.size())
+		{
+			MaterialRenderers[Materials[m_renderAdapter].MaterialType].Renderer->setRenderDevice(m_renderAdapter);
+			MaterialRenderers[Materials[m_renderAdapter].MaterialType].Renderer->OnSetMaterial(
+				Materials[m_renderAdapter], LastMaterials[m_renderAdapter], ResetRenderStatess[m_renderAdapter], this);
+		}
+	}
+
+	bool shaderOK = true;
+	if (Materials[m_renderAdapter].MaterialType >= 0 && Materials[m_renderAdapter].MaterialType < (s32)MaterialRenderers.size())
+	{
+		MaterialRenderers[Materials[m_renderAdapter].MaterialType].Renderer->setRenderDevice(m_renderAdapter);
+		shaderOK = MaterialRenderers[Materials[m_renderAdapter].MaterialType].Renderer->OnRender(this, LastVertexTypes[m_renderAdapter]);
+	}
+
+	LastMaterials[m_renderAdapter] = Materials[m_renderAdapter];
+
+	ResetRenderStatess[m_renderAdapter] = false;
+
+	CurrentRenderMode = ERM_3D;
+
+	return shaderOK;
+}
+
+
+
+//! Can be called by an IMaterialRenderer to make its work easier.
+void CD3D9MDriver::setBasicRenderStates(const SMaterial& material, const SMaterial& lastmaterial,
+	bool resetAllRenderstates)
+{
+	if (resetAllRenderstates ||
+		lastmaterial.AmbientColor != material.AmbientColor ||
+		lastmaterial.DiffuseColor != material.DiffuseColor ||
+		lastmaterial.SpecularColor != material.SpecularColor ||
+		lastmaterial.EmissiveColor != material.EmissiveColor ||
+		lastmaterial.Shininess != material.Shininess)
+	{
+		D3DMATERIAL9 mat;
+		mat.Diffuse = colorToD3D(material.DiffuseColor);
+		mat.Ambient = colorToD3D(material.AmbientColor);
+		mat.Specular = colorToD3D(material.SpecularColor);
+		mat.Emissive = colorToD3D(material.EmissiveColor);
+		mat.Power = material.Shininess;
+		pID3DDevice->SetMaterial(&mat);
+	}
+
+	// Bilinear and/or trilinear
+	if (resetAllRenderstates ||
+		lastmaterial.BilinearFilter != material.BilinearFilter ||
+		lastmaterial.TrilinearFilter != material.TrilinearFilter ||
+		lastmaterial.AnisotropicFilter != material.AnisotropicFilter ||
+		!LastTextureMipMapsAvailable[0] ||
+		!LastTextureMipMapsAvailable[1])
+	{
+		if (material.BilinearFilter || material.TrilinearFilter || material.AnisotropicFilter)
+		{
+			pID3DDevice->SetSamplerState(0, D3DSAMP_MAGFILTER, material.AnisotropicFilter ? D3DTEXF_ANISOTROPIC : D3DTEXF_LINEAR);
+			pID3DDevice->SetSamplerState(0, D3DSAMP_MINFILTER, material.AnisotropicFilter ? D3DTEXF_ANISOTROPIC : D3DTEXF_LINEAR);
+			pID3DDevice->SetSamplerState(0, D3DSAMP_MIPFILTER, material.TrilinearFilter ? D3DTEXF_LINEAR : D3DTEXF_POINT);
+
+			pID3DDevice->SetSamplerState(1, D3DSAMP_MAGFILTER, material.AnisotropicFilter ? D3DTEXF_ANISOTROPIC : D3DTEXF_LINEAR);
+			pID3DDevice->SetSamplerState(1, D3DSAMP_MINFILTER, material.AnisotropicFilter ? D3DTEXF_ANISOTROPIC : D3DTEXF_LINEAR);
+			pID3DDevice->SetSamplerState(1, D3DSAMP_MIPFILTER, material.TrilinearFilter ? D3DTEXF_LINEAR : D3DTEXF_POINT);
+		}
+		else
+		{
+			pID3DDevice->SetSamplerState(0, D3DSAMP_MINFILTER, D3DTEXF_POINT);
+			pID3DDevice->SetSamplerState(0, D3DSAMP_MIPFILTER, D3DTEXF_NONE);
+			pID3DDevice->SetSamplerState(0, D3DSAMP_MAGFILTER, D3DTEXF_POINT);
+
+			pID3DDevice->SetSamplerState(1, D3DSAMP_MINFILTER, D3DTEXF_POINT);
+			pID3DDevice->SetSamplerState(1, D3DSAMP_MIPFILTER,  D3DTEXF_NONE);
+			pID3DDevice->SetSamplerState(1, D3DSAMP_MAGFILTER, D3DTEXF_POINT);
+		}
+	}
+
+	// fillmode
+
+	if (resetAllRenderstates || lastmaterial.Wireframe != material.Wireframe || lastmaterial.PointCloud != material.PointCloud)
+	{
+		if (material.Wireframe)
+			pID3DDevice->SetRenderState(D3DRS_FILLMODE, D3DFILL_WIREFRAME);
+		else
+		if (material.PointCloud)
+			pID3DDevice->SetRenderState(D3DRS_FILLMODE, D3DFILL_POINT);
+		else
+			pID3DDevice->SetRenderState(D3DRS_FILLMODE, D3DFILL_SOLID);
+	}
+
+	// shademode
+
+	if (resetAllRenderstates || lastmaterial.GouraudShading != material.GouraudShading)
+	{
+		if (material.GouraudShading)
+			pID3DDevice->SetRenderState(D3DRS_SHADEMODE, D3DSHADE_GOURAUD);
+		else
+			pID3DDevice->SetRenderState(D3DRS_SHADEMODE, D3DSHADE_FLAT);
+	}
+
+	// lighting
+
+	if (resetAllRenderstates || lastmaterial.Lighting != material.Lighting)
+	{
+		if (material.Lighting)
+			pID3DDevice->SetRenderState(D3DRS_LIGHTING, TRUE);
+		else
+			pID3DDevice->SetRenderState(D3DRS_LIGHTING, FALSE);
+	}
+
+	// zbuffer
+
+	if (resetAllRenderstates || lastmaterial.ZBuffer != material.ZBuffer)
+	{
+		if (material.ZBuffer)
+			pID3DDevice->SetRenderState(D3DRS_ZENABLE, TRUE);
+		else
+			pID3DDevice->SetRenderState(D3DRS_ZENABLE, FALSE);
+	}
+
+	// zwrite
+	if (resetAllRenderstates || lastmaterial.ZWriteEnable != material.ZWriteEnable)
+	{
+		if (material.ZWriteEnable)
+			pID3DDevice->SetRenderState( D3DRS_ZWRITEENABLE, TRUE);
+		else
+			pID3DDevice->SetRenderState( D3DRS_ZWRITEENABLE, FALSE);
+	}
+
+	// back face culling
+
+	if (resetAllRenderstates || lastmaterial.BackfaceCulling != material.BackfaceCulling)
+	{
+		if (material.BackfaceCulling)
+			pID3DDevice->SetRenderState( D3DRS_CULLMODE, D3DCULL_CCW);
+		else
+			pID3DDevice->SetRenderState( D3DRS_CULLMODE, D3DCULL_NONE);
+	}
+
+	// fog
+	if (resetAllRenderstates || lastmaterial.FogEnable != material.FogEnable)
+	{
+		pID3DDevice->SetRenderState(D3DRS_FOGENABLE, material.FogEnable);
+	}
+
+	// specular highlights
+	if (resetAllRenderstates || !core::equals(lastmaterial.Shininess,material.Shininess))
+	{
+		bool enable = (material.Shininess!=0.0f);
+		pID3DDevice->SetRenderState(D3DRS_SPECULARENABLE, enable);
+		pID3DDevice->SetRenderState(D3DRS_NORMALIZENORMALS, enable);
+		pID3DDevice->SetRenderState(D3DRS_SPECULARMATERIALSOURCE, D3DMCS_MATERIAL);
+	}
+
+	// normalization
+	if (resetAllRenderstates || lastmaterial.NormalizeNormals != material.NormalizeNormals)
+	{
+		pID3DDevice->SetRenderState(D3DRS_NORMALIZENORMALS,  material.NormalizeNormals);
+	}
+}
+
+
+
+//! sets the needed renderstates
+void CD3D9MDriver::setRenderStatesStencilShadowMode(bool zfail)
+{
+	if ((CurrentRenderMode != ERM_SHADOW_VOLUME_ZFAIL &&
+		CurrentRenderMode != ERM_SHADOW_VOLUME_ZPASS) ||
+		Transformation3DChanged)
+	{
+		// switch back the matrices
+		pID3DDevice->SetTransform(D3DTS_VIEW, (D3DMATRIX*)((void*)&Matricess[m_renderAdapter][ETS_VIEW]));
+		pID3DDevice->SetTransform(D3DTS_WORLD, (D3DMATRIX*)((void*)&Matricess[m_renderAdapter][ETS_WORLD]));
+		pID3DDevice->SetTransform(D3DTS_PROJECTION, (D3DMATRIX*)((void*)&Matricess[m_renderAdapter][ETS_PROJECTION]));
+
+		Transformation3DChanged = false;
+
+		setTexture(0,0);
+		setTexture(1,0);
+		setTexture(2,0);
+		setTexture(3,0);
+
+		pID3DDevice->SetTextureStageState(1, D3DTSS_COLOROP, D3DTOP_DISABLE);
+		pID3DDevice->SetTextureStageState(1, D3DTSS_ALPHAOP, D3DTOP_DISABLE);
+		pID3DDevice->SetTextureStageState(2, D3DTSS_COLOROP, D3DTOP_DISABLE);
+		pID3DDevice->SetTextureStageState(2, D3DTSS_ALPHAOP, D3DTOP_DISABLE);
+
+		pID3DDevice->SetFVF(D3DFVF_XYZ);
+		LastVertexTypes[m_renderAdapter] = (video::E_VERTEX_TYPE)(-1);
+
+		pID3DDevice->SetRenderState( D3DRS_ZWRITEENABLE,  FALSE );
+		pID3DDevice->SetRenderState( D3DRS_STENCILENABLE, TRUE );
+		pID3DDevice->SetRenderState( D3DRS_SHADEMODE, D3DSHADE_FLAT);
+
+		// unset last 3d material
+		if (CurrentRenderMode == ERM_3D &&
+			Materials[m_renderAdapter].MaterialType >= 0 && Materials[m_renderAdapter].MaterialType < (s32)MaterialRenderers.size())
+		{
+			MaterialRenderers[Materials[m_renderAdapter].MaterialType].Renderer->setRenderDevice(m_renderAdapter);
+			MaterialRenderers[Materials[m_renderAdapter].MaterialType].Renderer->OnUnsetMaterial();
+		}
+
+		//pID3DDevice->SetRenderState(D3DRS_FOGENABLE, FALSE);
+		//pID3DDevice->SetRenderState(D3DRS_ALPHATESTENABLE, FALSE);
+	}
+
+	if (CurrentRenderMode != ERM_SHADOW_VOLUME_ZPASS && !zfail)
+	{
+		// USE THE ZPASS METHOD
+
+		pID3DDevice->SetRenderState( D3DRS_STENCILFUNC,  D3DCMP_ALWAYS );
+		pID3DDevice->SetRenderState( D3DRS_STENCILZFAIL, D3DSTENCILOP_KEEP );
+		pID3DDevice->SetRenderState( D3DRS_STENCILFAIL,  D3DSTENCILOP_KEEP );
+
+		pID3DDevice->SetRenderState( D3DRS_STENCILREF,       0x1 );
+		pID3DDevice->SetRenderState( D3DRS_STENCILMASK,      0xffffffff );
+		pID3DDevice->SetRenderState( D3DRS_STENCILWRITEMASK, 0xffffffff );
+
+		pID3DDevice->SetRenderState( D3DRS_ALPHABLENDENABLE, TRUE);
+		pID3DDevice->SetRenderState( D3DRS_SRCBLEND,  D3DBLEND_ZERO );
+		pID3DDevice->SetRenderState( D3DRS_DESTBLEND, D3DBLEND_ONE );
+	}
+	else
+	if (CurrentRenderMode != ERM_SHADOW_VOLUME_ZFAIL && zfail)
+	{
+		// USE THE ZFAIL METHOD
+
+		pID3DDevice->SetRenderState( D3DRS_STENCILFUNC,  D3DCMP_ALWAYS );
+		pID3DDevice->SetRenderState( D3DRS_STENCILZFAIL, D3DSTENCILOP_KEEP );
+		pID3DDevice->SetRenderState( D3DRS_STENCILFAIL,  D3DSTENCILOP_KEEP );
+		pID3DDevice->SetRenderState( D3DRS_STENCILPASS,  D3DSTENCILOP_KEEP );
+
+		pID3DDevice->SetRenderState( D3DRS_STENCILREF,       0x0 );
+		pID3DDevice->SetRenderState( D3DRS_STENCILMASK,      0xffffffff );
+		pID3DDevice->SetRenderState( D3DRS_STENCILWRITEMASK, 0xffffffff );
+
+		pID3DDevice->SetRenderState( D3DRS_ALPHABLENDENABLE, TRUE );
+		pID3DDevice->SetRenderState( D3DRS_SRCBLEND,  D3DBLEND_ZERO );
+		pID3DDevice->SetRenderState( D3DRS_DESTBLEND, D3DBLEND_ONE );
+	}
+
+	CurrentRenderMode = zfail ? ERM_SHADOW_VOLUME_ZFAIL : ERM_SHADOW_VOLUME_ZPASS;
+}
+
+
+
+//! sets the needed renderstates
+void CD3D9MDriver::setRenderStatesStencilFillMode(bool alpha)
+{
+	if (CurrentRenderMode != ERM_STENCIL_FILL || Transformation3DChanged)
+	{
+		core::matrix4 mat;
+		pID3DDevice->SetTransform(D3DTS_VIEW, (D3DMATRIX*)((void*)&mat));
+		pID3DDevice->SetTransform(D3DTS_WORLD, (D3DMATRIX*)((void*)&mat));
+		pID3DDevice->SetTransform(D3DTS_PROJECTION, (D3DMATRIX*)((void*)&mat));
+
+		pID3DDevice->SetRenderState(D3DRS_ZENABLE, FALSE);
+		pID3DDevice->SetRenderState(D3DRS_LIGHTING, FALSE);
+		pID3DDevice->SetRenderState(D3DRS_FOGENABLE, FALSE);
+
+		pID3DDevice->SetTextureStageState(1, D3DTSS_COLOROP, D3DTOP_DISABLE);
+		pID3DDevice->SetTextureStageState(1, D3DTSS_ALPHAOP, D3DTOP_DISABLE);
+
+		pID3DDevice->SetRenderState( D3DRS_STENCILREF, 0x1);
+		pID3DDevice->SetRenderState(D3DRS_STENCILFUNC, D3DCMP_LESSEQUAL);
+		//pID3DDevice->SetRenderState(D3DRS_STENCILFUNC, D3DCMP_GREATEREQUAL);
+		pID3DDevice->SetRenderState(D3DRS_STENCILPASS, D3DSTENCILOP_KEEP );
+		pID3DDevice->SetRenderState( D3DRS_STENCILZFAIL, D3DSTENCILOP_KEEP );
+		pID3DDevice->SetRenderState( D3DRS_STENCILMASK,      0xffffffff );
+		pID3DDevice->SetRenderState( D3DRS_STENCILWRITEMASK, 0xffffffff );
+
+		pID3DDevice->SetRenderState( D3DRS_CULLMODE, D3DCULL_CCW);
+
+		Transformation3DChanged = false;
+
+		if (alpha)
+		{
+			pID3DDevice->SetTextureStageState( 0, D3DTSS_COLOROP,   D3DTOP_MODULATE );
+			pID3DDevice->SetTextureStageState( 0, D3DTSS_COLORARG1, D3DTA_TEXTURE );
+			pID3DDevice->SetTextureStageState( 0, D3DTSS_COLORARG2, D3DTA_DIFFUSE );
+			pID3DDevice->SetTextureStageState (0, D3DTSS_ALPHAOP,   D3DTOP_SELECTARG1);
+			pID3DDevice->SetTextureStageState (0, D3DTSS_ALPHAARG1, D3DTA_DIFFUSE );
+			pID3DDevice->SetRenderState(D3DRS_ALPHABLENDENABLE, TRUE);
+			pID3DDevice->SetRenderState(D3DRS_SRCBLEND, D3DBLEND_SRCALPHA);
+			pID3DDevice->SetRenderState(D3DRS_DESTBLEND, D3DBLEND_INVSRCALPHA );
+		}
+		else
+		{
+			pID3DDevice->SetTextureStageState( 0, D3DTSS_COLOROP,   D3DTOP_MODULATE );
+			pID3DDevice->SetTextureStageState( 0, D3DTSS_COLORARG1, D3DTA_TEXTURE );
+			pID3DDevice->SetTextureStageState( 0, D3DTSS_COLORARG2, D3DTA_DIFFUSE );
+			pID3DDevice->SetTextureStageState( 0, D3DTSS_ALPHAOP,  D3DTOP_DISABLE );
+			pID3DDevice->SetRenderState(D3DRS_ALPHABLENDENABLE, FALSE);
+		}
+	}
+
+	CurrentRenderMode = ERM_STENCIL_FILL;
+}
+
+
+
+//! sets the needed renderstates
+void CD3D9MDriver::setRenderStates2DMode(bool alpha, bool texture, bool alphaChannel)
+{
+	if (!pID3DDevice)
+		return;
+
+	if (CurrentRenderMode != ERM_2D || Transformation3DChanged)
+	{
+		core::matrix4 mat;
+		core::matrix4 mat1;
+		pID3DDevice->SetTransform(D3DTS_VIEW, (D3DMATRIX*)((void*)&mat));
+		pID3DDevice->SetTransform(D3DTS_WORLD, (D3DMATRIX*)((void*)&mat));
+		pID3DDevice->SetTransform(D3DTS_PROJECTION, (D3DMATRIX*)((void*)&mat));
+
+		pID3DDevice->SetRenderState(D3DRS_ZENABLE, FALSE);
+		//pID3DDevice->SetRenderState(D3DRS_SHADEMODE, D3DSHADE_FLAT);
+		pID3DDevice->SetRenderState(D3DRS_FILLMODE, D3DFILL_SOLID);
+		pID3DDevice->SetRenderState(D3DRS_LIGHTING, FALSE);
+		pID3DDevice->SetRenderState(D3DRS_FOGENABLE, FALSE);
+		pID3DDevice->SetRenderState(D3DRS_SPECULARENABLE, FALSE);
+
+		pID3DDevice->SetTextureStageState(1, D3DTSS_COLOROP, D3DTOP_DISABLE);
+		pID3DDevice->SetTextureStageState(1, D3DTSS_ALPHAOP, D3DTOP_DISABLE);
+
+		pID3DDevice->SetRenderState( D3DRS_STENCILENABLE, FALSE );
+
+		pID3DDevice->SetRenderState( D3DRS_CULLMODE, D3DCULL_CCW );
+
+		pID3DDevice->SetTextureStageState( 0, D3DTSS_TEXTURETRANSFORMFLAGS, D3DTTFF_DISABLE );
+		pID3DDevice->SetTextureStageState( 0, D3DTSS_TEXCOORDINDEX, 0);
+
+		pID3DDevice->SetTransform( D3DTS_TEXTURE0, (D3DMATRIX*)((void*)&mat1) );//??
+
+		Transformation3DChanged = false;
+
+		// unset last 3d material
+		if (CurrentRenderMode == ERM_3D &&
+			Materials[m_renderAdapter].MaterialType >= 0 && Materials[m_renderAdapter].MaterialType < (s32)MaterialRenderers.size())
+		{
+			MaterialRenderers[Materials[m_renderAdapter].MaterialType].Renderer->setRenderDevice(m_renderAdapter);
+			MaterialRenderers[Materials[m_renderAdapter].MaterialType].Renderer->OnUnsetMaterial();
+		}
+	}
+
+	if (texture)
+	{
+		pID3DDevice->SetSamplerState(0, D3DSAMP_MINFILTER, D3DTEXF_POINT);
+		pID3DDevice->SetSamplerState(0, D3DSAMP_MIPFILTER, D3DTEXF_NONE);
+		pID3DDevice->SetSamplerState(0, D3DSAMP_MAGFILTER, D3DTEXF_POINT);
+
+		if (alphaChannel)
+		{
+			pID3DDevice->SetTextureStageState( 0, D3DTSS_COLOROP,   D3DTOP_MODULATE );
+			pID3DDevice->SetTextureStageState( 0, D3DTSS_COLORARG1, D3DTA_TEXTURE );
+			pID3DDevice->SetTextureStageState( 0, D3DTSS_COLORARG2, D3DTA_DIFFUSE );
+
+			if (alpha)
+			{
+				pID3DDevice->SetTextureStageState (0, D3DTSS_ALPHAOP,  D3DTOP_MODULATE );
+				pID3DDevice->SetTextureStageState (0, D3DTSS_ALPHAARG1, D3DTA_TEXTURE );
+				pID3DDevice->SetTextureStageState (0, D3DTSS_ALPHAARG2, D3DTA_DIFFUSE );
+			}
+			else
+			{
+				pID3DDevice->SetTextureStageState (0, D3DTSS_ALPHAOP,  D3DTOP_SELECTARG1 );
+				pID3DDevice->SetTextureStageState (0, D3DTSS_ALPHAARG1, D3DTA_TEXTURE );
+			}
+
+			pID3DDevice->SetRenderState(D3DRS_ALPHABLENDENABLE, TRUE);
+			pID3DDevice->SetRenderState(D3DRS_SRCBLEND, D3DBLEND_SRCALPHA);
+			pID3DDevice->SetRenderState(D3DRS_DESTBLEND, D3DBLEND_INVSRCALPHA );
+		}
+		else
+		{
+			if (alpha)
+			{
+				pID3DDevice->SetTextureStageState(0, D3DTSS_ALPHAOP, D3DTOP_SELECTARG2);
+				pID3DDevice->SetTextureStageState(0, D3DTSS_COLORARG2, D3DTA_DIFFUSE );
+				pID3DDevice->SetRenderState(D3DRS_ALPHABLENDENABLE, TRUE);
+				pID3DDevice->SetRenderState(D3DRS_SRCBLEND, D3DBLEND_SRCALPHA);
+				pID3DDevice->SetRenderState(D3DRS_DESTBLEND, D3DBLEND_INVSRCALPHA );
+			}
+			else
+			{
+				pID3DDevice->SetTextureStageState( 0, D3DTSS_COLOROP,   D3DTOP_MODULATE );
+				pID3DDevice->SetTextureStageState( 0, D3DTSS_COLORARG1, D3DTA_TEXTURE );
+				pID3DDevice->SetTextureStageState( 0, D3DTSS_COLORARG2, D3DTA_DIFFUSE );
+				pID3DDevice->SetTextureStageState( 0, D3DTSS_ALPHAOP,  D3DTOP_DISABLE);
+				pID3DDevice->SetRenderState(D3DRS_ALPHABLENDENABLE, FALSE);
+			}
+		}
+	}
+	else
+	{
+		if (alpha)
+		{
+			pID3DDevice->SetTextureStageState( 0, D3DTSS_COLOROP,   D3DTOP_MODULATE );
+			pID3DDevice->SetTextureStageState( 0, D3DTSS_COLORARG1, D3DTA_TEXTURE );
+			pID3DDevice->SetTextureStageState( 0, D3DTSS_COLORARG2, D3DTA_DIFFUSE );
+			pID3DDevice->SetTextureStageState( 0, D3DTSS_ALPHAOP,  D3DTOP_SELECTARG1);
+			pID3DDevice->SetTextureStageState( 0, D3DTSS_ALPHAARG1, D3DTA_DIFFUSE );
+			pID3DDevice->SetRenderState(D3DRS_ALPHABLENDENABLE, TRUE);
+			pID3DDevice->SetRenderState(D3DRS_SRCBLEND, D3DBLEND_SRCALPHA);
+			pID3DDevice->SetRenderState(D3DRS_DESTBLEND, D3DBLEND_INVSRCALPHA );
+		}
+		else
+		{
+			pID3DDevice->SetTextureStageState( 0, D3DTSS_COLOROP,   D3DTOP_MODULATE );
+			pID3DDevice->SetTextureStageState( 0, D3DTSS_COLORARG1, D3DTA_TEXTURE );
+			pID3DDevice->SetTextureStageState( 0, D3DTSS_COLORARG2, D3DTA_DIFFUSE );
+			pID3DDevice->SetTextureStageState( 0, D3DTSS_ALPHAOP,  D3DTOP_DISABLE);
+			pID3DDevice->SetRenderState(D3DRS_ALPHABLENDENABLE, FALSE);
+		}
+	}
+
+	CurrentRenderMode = ERM_2D;
+}
+
+
+
+//! deletes all dynamic lights there are
+void CD3D9MDriver::deleteAllDynamicLights()
+{
+	for (s32 i=0; i<LastSetLights[m_renderAdapter]+1; ++i)
+		pID3DDevice->LightEnable(i, false);
+
+	LastSetLights[m_renderAdapter] = -1;
+
+	CNullDriver::deleteAllDynamicLights();
+}
+
+
+
+//! adds a dynamic light
+void CD3D9MDriver::addDynamicLight(const SLight& dl)
+{
+	if ((u32)LastSetLights[m_renderAdapter] == Capss[m_renderAdapter].MaxActiveLights-1)
+		return;
+
+	CNullDriver::addDynamicLight(dl);
+
+	D3DLIGHT9 light;
+
+	if ( dl.Type == ELT_POINT )
+	{
+		light.Type = D3DLIGHT_POINT;
+		light.Position = *(D3DVECTOR*)((void*)(&dl.Position));
+	}
+	else
+	if ( dl.Type == ELT_DIRECTIONAL )
+	{
+		light.Type = D3DLIGHT_DIRECTIONAL;
+		light.Direction = *(D3DVECTOR*)((void*)(&dl.Position));
+	}
+
+	light.Diffuse = *(D3DCOLORVALUE*)((void*)(&dl.DiffuseColor));
+	light.Specular = *(D3DCOLORVALUE*)((void*)(&dl.SpecularColor));
+	light.Ambient = *(D3DCOLORVALUE*)((void*)(&dl.AmbientColor));
+	light.Range = MaxLightDistance;
+
+	light.Attenuation0 = 0.0f;
+	light.Attenuation1 = 1.0f / dl.Radius;
+	light.Attenuation2 = 0.0f;
+
+	++LastSetLights[m_renderAdapter];
+	pID3DDevice->SetLight(LastSetLights[m_renderAdapter], &light);
+	pID3DDevice->LightEnable(LastSetLights[m_renderAdapter], true);
+}
+
+
+
+//! returns the maximal amount of dynamic lights the device can handle
+s32 CD3D9MDriver::getMaximalDynamicLightAmount()
+{
+	return Capss[m_renderAdapter].MaxActiveLights;
+}
+
+
+
+//! Sets the dynamic ambient light color. The default color is
+//! (0,0,0,0) which means it is dark.
+//! \param color: New color of the ambient light.
+void CD3D9MDriver::setAmbientLight(const SColorf& color)
+{
+	if (!pID3DDevice)
+		return;
+
+	AmbientLight = color;
+	D3DCOLOR col = color.toSColor().color;
+	pID3DDevice->SetRenderState(D3DRS_AMBIENT, col);
+	//for(u32 idx = 0; idx = pID3DDevices.size(); ++idx)
+	//{
+	//	if(pID3DDevices[idx])
+	//		pID3DDevices[idx]->SetRenderState(D3DRS_AMBIENT, col);
+	//}
+}
+
+
+
+//! \return Returns the name of the video driver. Example: In case of the DIRECT3D9
+//! driver, it would return "Direct3D9.1".
+const wchar_t* CD3D9MDriver::getName()
+{
+	return L"Direct3D 9.0";
+}
+
+
+
+//! Draws a shadow volume into the stencil buffer. To draw a stencil shadow, do
+//! this: Frist, draw all geometry. Then use this method, to draw the shadow
+//! volume. Then, use IVideoDriver::drawStencilShadow() to visualize the shadow.
+void CD3D9MDriver::drawStencilShadowVolume(const core::vector3df* triangles, s32 count, bool zfail)
+{
+	if (!StencilBuffer || !count)
+		return;
+
+	if(!beginPartScene())
+	{
+		os::Printer::log("DirectX9 beginPartScene failed.", ELL_WARNING);
+		return;
+	}
+	setRenderStatesStencilShadowMode(zfail);
+
+	if (!zfail)
+	{
+		// ZPASS Method
+
+		// Draw front-side of shadow volume in stencil/z only
+		pID3DDevice->SetRenderState(D3DRS_CULLMODE, D3DCULL_CCW );
+		pID3DDevice->SetRenderState(D3DRS_STENCILPASS, D3DSTENCILOP_INCRSAT);
+		pID3DDevice->DrawPrimitiveUP(D3DPT_TRIANGLELIST, count / 3, triangles, sizeof(core::vector3df));
+
+		// Now reverse cull order so front sides of shadow volume are written.
+		pID3DDevice->SetRenderState( D3DRS_CULLMODE,   D3DCULL_CW );
+		pID3DDevice->SetRenderState( D3DRS_STENCILPASS, D3DSTENCILOP_DECRSAT);
+		pID3DDevice->DrawPrimitiveUP(D3DPT_TRIANGLELIST, count / 3, triangles, sizeof(core::vector3df));
+	}
+	else
+	{
+		// ZFAIL Method
+
+		// Draw front-side of shadow volume in stencil/z only
+		pID3DDevice->SetRenderState(D3DRS_CULLMODE, D3DCULL_CW );
+		pID3DDevice->SetRenderState(D3DRS_STENCILZFAIL, D3DSTENCILOP_INCRSAT );
+		pID3DDevice->DrawPrimitiveUP(D3DPT_TRIANGLELIST, count / 3, triangles, sizeof(core::vector3df));
+
+		// Now reverse cull order so front sides of shadow volume are written.
+		pID3DDevice->SetRenderState( D3DRS_CULLMODE,   D3DCULL_CCW );
+		pID3DDevice->SetRenderState( D3DRS_STENCILZFAIL,  D3DSTENCILOP_DECRSAT );
+		pID3DDevice->DrawPrimitiveUP(D3DPT_TRIANGLELIST, count / 3, triangles, sizeof(core::vector3df));
+	}
+	endPartScene();
+}
+
+
+
+//! Fills the stencil shadow with color. After the shadow volume has been drawn
+//! into the stencil buffer using IVideoDriver::drawStencilShadowVolume(), use this
+//! to draw the color of the shadow.
+void CD3D9MDriver::drawStencilShadow(bool clearStencilBuffer, video::SColor leftUpEdge,
+			video::SColor rightUpEdge, video::SColor leftDownEdge, video::SColor rightDownEdge)
+{
+	if (!StencilBuffer)
+		return;
+
+	S3DVertex vtx[4];
+	vtx[0] = S3DVertex(1.0f, 1.0f, 0.0f, 0.0f, 0.0f, 0.0f, leftUpEdge, 0.0f, 0.0f);
+	vtx[1] = S3DVertex(1.0f, -1.0f, 0.0f, 0.0f, 0.0f, 0.0f, rightUpEdge, 0.0f, 1.0f);
+	vtx[2] = S3DVertex(-1.0f, 1.0f, 0.0f, 0.0f, 0.0f, 0.0f, leftDownEdge, 1.0f, 0.0f);
+	vtx[3] = S3DVertex(-1.0f, -1.0f, 0.0f, 0.0f, 0.0f, 0.0f, rightDownEdge, 1.0f, 1.0f);
+
+	s16 indices[6] = {0,1,2,1,3,2};
+
+	if(!beginPartScene())
+	{
+		os::Printer::log("DirectX9 beginPartScene failed.", ELL_WARNING);
+		return;
+	}
+	setRenderStatesStencilFillMode(
+		leftUpEdge.getAlpha() < 255 ||
+		rightUpEdge.getAlpha() < 255 ||
+		leftDownEdge.getAlpha() < 255 ||
+		rightDownEdge.getAlpha() < 255);
+
+	setTexture(0,0);
+
+	setVertexShader(EVT_STANDARD);
+
+	pID3DDevice->DrawIndexedPrimitiveUP(D3DPT_TRIANGLELIST, 0, 4, 2, &indices[0],
+										D3DFMT_INDEX16, &vtx[0], sizeof(S3DVertex));
+
+	if (clearStencilBuffer)
+		pID3DDevice->Clear( 0, NULL, D3DCLEAR_STENCIL,0, 1.0, 0);
+
+	endPartScene();
+}
+
+
+
+//! Returns the maximum amount of primitives (mostly vertices) which
+//! the device is able to render with one drawIndexedTriangleList
+//! call.
+s32 CD3D9MDriver::getMaximalPrimitiveCount()
+{
+	return Capss[m_renderAdapter].MaxPrimitiveCount;
+}
+
+
+
+//! Sets the fog mode.
+void CD3D9MDriver::setFog(SColor color, bool linearFog, f32 start,
+	f32 end, f32 density, bool pixelFog, bool rangeFog)
+{
+	CNullDriver::setFog(color, linearFog, start, end, density, pixelFog, rangeFog);
+
+	if (!pID3DDevice)
+		return;
+
+	pID3DDevice->SetRenderState(D3DRS_FOGCOLOR, color.color);
+
+	pID3DDevice->SetRenderState(
+		pixelFog  ? D3DRS_FOGTABLEMODE : D3DRS_FOGVERTEXMODE,
+		linearFog ? D3DFOG_LINEAR : D3DFOG_EXP);
+
+	if(linearFog)
+	{
+		pID3DDevice->SetRenderState(D3DRS_FOGSTART, *(DWORD*)(&start));
+		pID3DDevice->SetRenderState(D3DRS_FOGEND, *(DWORD*)(&end));
+	}
+	else
+		pID3DDevice->SetRenderState(D3DRS_FOGDENSITY, *(DWORD*)(&density));
+
+	if(!pixelFog)
+		pID3DDevice->SetRenderState(D3DRS_RANGEFOGENABLE, rangeFog);
+}
+
+
+
+//! Draws a 3d line.
+void CD3D9MDriver::draw3DLine(const core::vector3df& start,
+	const core::vector3df& end, SColor color)
+{
+	if(!beginPartScene())
+	{
+		os::Printer::log("DirectX9 beginPartScene failed.", ELL_WARNING);
+		return;
+	}
+	setVertexShader(EVT_STANDARD);
+	setRenderStates3DMode();
+	video::S3DVertex v[2];
+	v[0].Color = color;
+	v[1].Color = color;
+	v[0].Pos = start;
+	v[1].Pos = end;
+
+	pID3DDevice->DrawPrimitiveUP(D3DPT_LINELIST, 1, v, sizeof(S3DVertex));
+	endPartScene();
+}
+
+
+
+//! resets the device
+bool CD3D9MDriver::reset()
+{
+    // reset
+	os::Printer::log("Resetting D3D9 device.", ELL_INFORMATION);
+	bool state = true;
+	//push the current device
+	IDirect3DDevice9* oldpID3DDevice = pID3DDevice;
+	for(u32 idx = 0; idx < pID3DDevices.size(); ++idx)
+	{
+		pID3DDevice = pID3DDevices[idx];
+		if (FAILED(pID3DDevice->Reset(m_pPresentParams[idx])))
+		{
+			char tmp[255];
+			sprintf(tmp, "Resetting failed. index: %d", idx);
+			os::Printer::log(tmp, ELL_WARNING);
+			return false;
+		}
+		DeviceLost = false;
+		ResetRenderStatess[m_renderAdapter] = true;
+		LastVertexTypes[m_renderAdapter] = (E_VERTEX_TYPE)-1;
+
+		for (s32 i=0; i<MATERIAL_MAX_TEXTURES; ++i)
+		{
+			if (CurrentTexture[i])
+				CurrentTexture[i]->drop();
+
+			CurrentTexture[i] = 0;
+		}
+
+		setVertexShader(EVT_STANDARD);
+		setRenderStates3DMode();
+		setFog(FogColor, LinearFog, FogStart, FogEnd, FogDensity, PixelFog, RangeFog);
+		setAmbientLight(AmbientLight);
+	}
+	pID3DDevice = oldpID3DDevice;
+
+	return true;
+}
+
+
+
+void CD3D9MDriver::OnResize(const core::dimension2d<s32>& size)
+{
+	return;
+}
+
+
+
+//! Returns type of video driver
+E_DRIVER_TYPE CD3D9MDriver::getDriverType()
+{
+	return EDT_DIRECT3D9;
+}
+
+
+
+//! Returns the transformation set by setTransform
+const core::matrix4& CD3D9MDriver::getTransform(E_TRANSFORMATION_STATE state)
+{
+	return Matricess[m_renderAdapter][state];
+}
+
+
+
+//! Sets a vertex shader constant.
+void CD3D9MDriver::setVertexShaderConstant(const f32* data, s32 startRegister, s32 constantAmount)
+{
+	if (data)
+		pID3DDevices[m_renderAdapter]->SetVertexShaderConstantF(startRegister, data, constantAmount);
+}
+
+//! Sets a pixel shader constant.
+void CD3D9MDriver::setPixelShaderConstant(const f32* data, s32 startRegister, s32 constantAmount)
+{
+	if (data)
+		pID3DDevices[m_renderAdapter]->SetPixelShaderConstantF(startRegister, data, constantAmount);
+}
+
+//! Sets a constant for the vertex shader based on a name.
+bool CD3D9MDriver::setVertexShaderConstant(const c8* name, const f32* floats, int count)
+{
+	if (Materials[m_renderAdapter].MaterialType >= 0 && Materials[m_renderAdapter].MaterialType < (s32)MaterialRenderers.size())
+	{
+		CD3D9MaterialRenderer* r = (CD3D9MaterialRenderer*)MaterialRenderers[Materials[m_renderAdapter].MaterialType].Renderer;
+		r->setRenderDevice(m_renderAdapter);
+		return r->setVariable(true, name, floats, count);
+	}
+
+	return false;
+}
+
+//! Sets a constant for the pixel shader based on a name.
+bool CD3D9MDriver::setPixelShaderConstant(const c8* name, const f32* floats, int count)
+{
+	if (Materials[m_renderAdapter].MaterialType >= 0 && Materials[m_renderAdapter].MaterialType < (s32)MaterialRenderers.size())
+	{
+		CD3D9MaterialRenderer* r = (CD3D9MaterialRenderer*)MaterialRenderers[Materials[m_renderAdapter].MaterialType].Renderer;
+		r->setRenderDevice(m_renderAdapter);
+		return r->setVariable(false, name, floats, count);
+	}
+
+	return false;
+}
+
+//! Returns pointer to the IGPUProgrammingServices interface.
+IGPUProgrammingServices* CD3D9MDriver::getGPUProgrammingServices()
+{
+	return this;
+}
+
+//! Adds a new material renderer to the VideoDriver, using pixel and/or
+//! vertex shaders to render geometry.
+s32 CD3D9MDriver::addShaderMaterial(const c8* vertexShaderProgram,
+	const c8* pixelShaderProgram,
+	IShaderConstantSetCallBack* callback,
+	E_MATERIAL_TYPE baseMaterial, s32 userData)
+{
+	s32 nr = -1;
+	CD3D9ShaderMaterialRenderer* r = new CD3D9ShaderMaterialRenderer(
+		pID3DDevices, this, nr, vertexShaderProgram, pixelShaderProgram,
+		callback, getMaterialRenderer(baseMaterial), userData);
+
+	r->drop();
+	return nr;
+}
+
+
+//! Adds a new material renderer to the VideoDriver, based on a high level shading
+//! language.
+s32 CD3D9MDriver::addHighLevelShaderMaterial(
+	const c8* vertexShaderProgram,
+	const c8* vertexShaderEntryPointName,
+	E_VERTEX_SHADER_TYPE vsCompileTarget,
+	const c8* pixelShaderProgram,
+	const c8* pixelShaderEntryPointName,
+	E_PIXEL_SHADER_TYPE psCompileTarget,
+	IShaderConstantSetCallBack* callback,
+	E_MATERIAL_TYPE baseMaterial,
+	s32 userData)
+{
+	s32 nr = -1;
+
+	CD3D9HLSLMaterialRenderer* hlsl = new CD3D9HLSLMaterialRenderer(
+		pID3DDevices, this, nr,
+		vertexShaderProgram,
+		vertexShaderEntryPointName,
+		vsCompileTarget,
+		pixelShaderProgram,
+		pixelShaderEntryPointName,
+		psCompileTarget,
+		callback,
+		getMaterialRenderer(baseMaterial),
+		userData);
+
+	hlsl->drop();
+	return nr;
+}
+
+
+//! Returns a pointer to the IVideoDriver interface. (Implementation for
+//! IMaterialRendererServices)
+IVideoDriver* CD3D9MDriver::getVideoDriver()
+{
+	return this;
+}
+
+
+//! Creates a render target texture.
+ITexture* CD3D9MDriver::createRenderTargetTexture(const core::dimension2d<s32>& size)
+{
+	return new CD3D9Texture(this, pID3DDevices, size, 0);
+}
+
+
+//! Clears the ZBuffer.
+void CD3D9MDriver::clearZBuffer()
+{
+	HRESULT hr = pID3DDevice->Clear( 0, NULL, D3DCLEAR_ZBUFFER, 0, 1.0, 0);
+
+	if (FAILED(hr))
+		os::Printer::log("CD3D9MDriver clearZBuffer() failed.", ELL_WARNING);
+}
+
+
+//! Returns an image created from the last rendered frame.
+IImage* CD3D9MDriver::createScreenShot()
+{
+	HRESULT hr;
+
+	// query the screen dimensions of the current adapter
+	D3DDISPLAYMODE displayMode;
+	pID3DDevice->GetDisplayMode(0, &displayMode);
+
+	// create the image surface to store the front buffer image [always A8R8G8B8]
+	LPDIRECT3DSURFACE9 lpSurface;
+	if (FAILED(hr = pID3DDevice->CreateOffscreenPlainSurface(displayMode.Width, displayMode.Height, D3DFMT_A8R8G8B8, D3DPOOL_SCRATCH, &lpSurface, 0)))
+		return 0;
+
+	// read the front buffer into the image surface
+	if (FAILED(hr = pID3DDevice->GetFrontBufferData(0, lpSurface)))
+	{
+		lpSurface->Release();
+		return 0;
+	}
+
+	RECT clientRect;
+	{
+		POINT clientPoint;
+		clientPoint.x = 0;
+		clientPoint.y = 0;
+
+		ClientToScreen((HWND)getExposedVideoData().D3D8.HWnd, &clientPoint);
+
+		clientRect.left   = clientPoint.x;
+		clientRect.top    = clientPoint.y;
+		clientRect.right  = clientRect.left + ScreenSize.Width;
+		clientRect.bottom = clientRect.top  + ScreenSize.Height;
+	}
+
+	// lock our area of the surface
+	D3DLOCKED_RECT lockedRect;
+	if (FAILED(lpSurface->LockRect(&lockedRect, &clientRect, D3DLOCK_READONLY)))
+	{
+		lpSurface->Release();
+		return 0;
+	}
+
+	// this could throw, but we aren't going to worry about that case very much
+	IImage* newImage = new CImage(ECF_A8R8G8B8, ScreenSize);
+
+	// d3d pads the image, so we need to copy the correct number of bytes
+	u32* pPixels = (u32*)newImage->lock();
+	if (pPixels)
+	{
+		u8 * sP = (u8 *)lockedRect.pBits;
+		u32* dP = (u32*)pPixels;
+
+		s32 y;
+		for (y = 0; y < ScreenSize.Height; ++y)
+		{
+			memcpy(dP, sP, ScreenSize.Width * 4);
+
+			sP += lockedRect.Pitch;
+			dP += ScreenSize.Width;
+		}
+
+		newImage->unlock();
+	}
+
+	// we can unlock and release the surface
+	lpSurface->UnlockRect();
+
+	// release the image surface
+	lpSurface->Release();
+
+	// return status of save operation to caller
+	return newImage;
+}
+
+
+// returns the current size of the screen or rendertarget
+core::dimension2d<s32> CD3D9MDriver::getCurrentRenderTargetSize()
+{
+	if ( CurrentRendertargetSize.Width == 0 )
+		return ScreenSize;
+	else
+		return CurrentRendertargetSize;
+}
+
+int CD3D9MDriver::getMultiheadDevicesCount()
+{
+	if(!initDirect3DInterface())
+		return 0;
+
+    UINT adapterCount = pID3D->GetAdapterCount();
+	int result = 0;
+	
+    for ( UINT i = 0; i < adapterCount; i++ )
+    {
+		// Get caps only for HAL device
+		D3DCAPS9 caps;
+		pID3D->GetDeviceCaps( i, D3DDEVTYPE_HAL, &caps );
+
+		// Look for multi-head adpater
+		if ( caps.NumberOfAdaptersInGroup > 1 )
+		{
+			result += caps.NumberOfAdaptersInGroup;
+		}
+    }
+
+	return result;
+}
+
+
+} // end namespace video
+} // end namespace irr
+
+#endif // _IRR_COMPILE_WITH_DIRECT3D_9_
+#endif // _IRR_WINDOWS_
+
+
+
+
+namespace irr
+{
+namespace video
+{
+
+#if (defined(_IRR_WINDOWS_) || defined(_XBOX))
+IVideoDriver* createDirectX9DriverMultihead(const core::array<core::dimension2d<s32> >& screenSize, core::array<HWND> window,
+											u32 bits, bool fullscreen, bool stencilbuffer,
+											io::IFileSystem* io, bool pureSoftware, bool highPrecisionFPU, bool vsync,
+											bool antiAlias)
+{
+    #ifdef _IRR_COMPILE_WITH_DIRECT3D_9_
+	CD3D9MDriver* dx9 =  new CD3D9MDriver(screenSize[0], window[0], fullscreen, stencilbuffer, io, pureSoftware);
+	if (!dx9->initDriver(screenSize, window, bits, fullscreen, pureSoftware, highPrecisionFPU, vsync, antiAlias))
+	{
+		dx9->drop();
+		dx9 = 0;
+	}
+
+	return dx9;
+	
+	#else
+	
+	return 0;
+	
+	#endif // _IRR_COMPILE_WITH_DIRECT3D_9_
+}
+int getDirectX9MultiheadAdapterCount()
+{
+    #ifdef _IRR_COMPILE_WITH_DIRECT3D_9_
+	CD3D9MDriver *dx9 = new CD3D9MDriver(core::dimension2d<s32>(10,10), NULL, true, true, NULL, false);
+	s32 adapterCount = dx9->getMultiheadDevicesCount();
+	dx9->drop();
+	dx9 = 0;
+
+	return adapterCount;
+	
+	#else
+	
+	return 0;
+	
+	#endif // _IRR_COMPILE_WITH_DIRECT3D_9_
+}
+#endif
+
+} // end namespace video
+} // end namespace irr
+
